SystemOrganization addCategory: #'GT-Spotter'!
SystemOrganization addCategory: 'GT-Spotter-Announcements'!
SystemOrganization addCategory: 'GT-Spotter-Async'!
SystemOrganization addCategory: 'GT-Spotter-Model'!
SystemOrganization addCategory: 'GT-Spotter-Processors'!
SystemOrganization addCategory: 'GT-Spotter-Renderer'!
SystemOrganization addCategory: 'GT-Spotter-Tests'!
SystemOrganization addCategory: 'GT-Spotter-Theme'!
SystemOrganization addCategory: 'GT-Spotter-UI'!
SystemOrganization addCategory: 'GT-Spotter-Utils'!

GLMBrick subclass: #GTSpotterContentsBrick
	instanceVariableNames: 'headerBrick dropDownBrick spotterModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-UI'!

!GTSpotterContentsBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/20/2014 23:26'!
dropDownBrick
	^ dropDownBrick! !

!GTSpotterContentsBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/20/2014 23:26'!
dropDownBrick: aBrick
	
	dropDownBrick ifNotNil: [self removeBrick: dropDownBrick].
	dropDownBrick := aBrick.
	
	dropDownBrick pagerModel: self spotterModel pagerModel.
	self theme spotterWidgetThemer dropDownPaneStyleFor: dropDownBrick.
	
	self addBrickBack: dropDownBrick! !

!GTSpotterContentsBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/20/2014 23:26'!
headerBrick
	^ headerBrick! !

!GTSpotterContentsBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/20/2014 23:26'!
headerBrick: aBrick
	
	headerBrick ifNotNil: [self removeBrick: headerBrick].
	headerBrick := aBrick.
	
	self theme spotterWidgetThemer headerStyleFor: headerBrick.
	
	self addBrickBack: headerBrick! !

!GTSpotterContentsBrick methodsFor: 'initialization' stamp: 'AliakseiSyrel 11/20/2014 23:27'!
initialize
	super initialize.
		
	self headerBrick: self newHeaderBrick.! !

!GTSpotterContentsBrick methodsFor: 'testing' stamp: 'AliakseiSyrel 11/20/2014 23:26'!
isDropDownPaneVisible

	^ self dropDownBrick isNotNil! !

!GTSpotterContentsBrick methodsFor: 'instance creation' stamp: 'TudorGirba 11/26/2014 14:35'!
newDropDownMorph

	^ GTSpotterDropDownMorph new! !

!GTSpotterContentsBrick methodsFor: 'instance creation' stamp: 'TudorGirba 11/26/2014 14:34'!
newHeaderBrick

	^ GTSpotterHeaderBrick new! !

!GTSpotterContentsBrick methodsFor: 'events-processing' stamp: 'AliakseiSyrel 11/20/2014 23:29'!
onStepAdded
	"as soon as step added I need to show drop down pane"
	self isDropDownPaneVisible ifTrue: [ ^ self ].
	
	self showDropDownPane! !

!GTSpotterContentsBrick methodsFor: 'actions' stamp: 'AliakseiSyrel 1/20/2015 01:29'!
showDropDownPane

	self dropDownBrick: self newDropDownMorph.
	self dropDownBrick spotterModel: self spotterModel.
	self doLayout! !

!GTSpotterContentsBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/20/2014 23:35'!
spotterModel

	^ spotterModel! !

!GTSpotterContentsBrick methodsFor: 'accessing' stamp: 'TudorGirba 11/26/2014 14:34'!
spotterModel: aModel

	spotterModel := aModel.
	self headerBrick spotterModel: spotterModel.
	
	spotterModel steps isEmpty ifFalse: [ spotterModel currentStep isEmpty ifFalse: [ self showDropDownPane ] ].

	spotterModel announcer subscribe: GTSpotterStepAdded send: #onStepAdded to: self.! !

GLMBrick subclass: #GTSpotterHeaderBrick
	instanceVariableNames: 'stepsBrick searchField closeButton spotterModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-UI'!

!GTSpotterHeaderBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/25/2015 20:15'!
closeButton: aBrick

	closeButton ifNotNil: [self removeBrick: closeButton].
	closeButton := aBrick.
	
	self theme spotterWidgetThemer closeButtonStyleFor: closeButton.
	
	closeButton layoutProperties staticWidth: self height.	"to make button being a square"
	closeButton addUpAction: [ self spotterModel exit ].
	
	self addBrickBack: closeButton! !

!GTSpotterHeaderBrick methodsFor: 'initialization' stamp: 'AliakseiSyrel 10/25/2014 10:44'!
initialize
	super initialize.
	
	self searchField: self newSearchField.
	self closeButton: self newCloseButton.
	! !

!GTSpotterHeaderBrick methodsFor: 'instance creation' stamp: 'AliakseiSyrel 10/22/2014 23:59'!
newCloseButton

	^ GLMActionButtonBrick new! !

!GTSpotterHeaderBrick methodsFor: 'instance creation' stamp: 'TudorGirba 11/26/2014 14:34'!
newSearchField

	^ GTSpotterSearchFieldMorph new! !

!GTSpotterHeaderBrick methodsFor: 'instance creation' stamp: 'AliaskeiSyrel 11/8/2014 17:33'!
newStepsBand

	^ GLMBrick new! !

!GTSpotterHeaderBrick methodsFor: 'event handling' stamp: 'AliakseiSyrel 11/15/2014 15:43'!
onCurrentStepChanged

	self searchField updateTextWith: self spotterModel currentStep query.
	self searchField moveCursorAtTheEnd! !

!GTSpotterHeaderBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/24/2014 10:29'!
searchField

	^ searchField! !

!GTSpotterHeaderBrick methodsFor: 'accessing' stamp: 'TudorGirba 11/26/2014 11:27'!
searchField: aMorph

	searchField ifNotNil: [self removeBrick: searchField].
	searchField := aMorph.
	
	self theme spotterWidgetThemer searchFieldStyleFor: searchField.
	
	searchField takeKeyboardFocus.
	
	self addBrickBack: searchField! !

!GTSpotterHeaderBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/24/2014 10:15'!
spotterModel

	^ spotterModel! !

!GTSpotterHeaderBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/27/2015 11:02'!
spotterModel: aModel 

	spotterModel := aModel.
	self searchField on: spotterModel.

	spotterModel announcer weak subscribe: GTSpotterCurrentStepChanged send: #onCurrentStepChanged to: self.! !

GLMBrick subclass: #GTSpotterItemActionbarBrick
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-UI'!

!GTSpotterItemActionbarBrick methodsFor: 'adding' stamp: 'AliakseiSyrel 11/27/2014 11:44'!
addActionButton: anActionButton

	self theme spotterWidgetThemer itemActionButtonStyleFor: anActionButton.

	self addBrickBack: anActionButton.! !

GLMBrick subclass: #GTSpotterPaneBrick
	instanceVariableNames: 'contentsBrick previewBrick arrowBrick'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-UI'!

!GTSpotterPaneBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/25/2015 18:30'!
arrowBrick

	^ arrowBrick! !

!GTSpotterPaneBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/25/2015 18:41'!
arrowBrick: aBrick

	arrowBrick := aBrick.
	self theme spotterWidgetThemer spotterPreviewArrowContainerStyleFor: self arrowBrick.
	self addBrickBack: self arrowBrick! !

!GTSpotterPaneBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/20/2015 00:58'!
contentsBrick

	^ contentsBrick! !

!GTSpotterPaneBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/20/2015 00:58'!
contentsBrick: aBrick
	
	contentsBrick ifNotNil: [self removeBrick: contentsBrick].
	contentsBrick := aBrick.
		
	self theme spotterWidgetThemer spotterContentsStyleFor: contentsBrick.

	self addBrickBack: contentsBrick! !

!GTSpotterPaneBrick methodsFor: 'action' stamp: 'AliakseiSyrel 1/25/2015 17:37'!
hidePreview

	self isPreviewShown ifFalse: [ ^ self ].

	self removeBrick: self previewBrick.
	self contentsBrick layout hSpaceFill.
	self doLayout.
	self changed.! !

!GTSpotterPaneBrick methodsFor: 'initialization' stamp: 'AliakseiSyrel 1/25/2015 18:30'!
initialize
	super initialize.
	
	self contentsBrick: self newContentsBrick.
	self arrowBrick: self newArrowBrick.
	self previewBrick: self newPreviewBrick! !

!GTSpotterPaneBrick methodsFor: 'testing' stamp: 'AliakseiSyrel 1/25/2015 17:15'!
isPreviewShown

	^ self hasSubbrick: self previewBrick! !

!GTSpotterPaneBrick methodsFor: 'instance creation' stamp: 'AliakseiSyrel 1/25/2015 18:29'!
newArrowBrick

	^ GTSpotterPreviewArrowBrick new! !

!GTSpotterPaneBrick methodsFor: 'instance creation' stamp: 'AliakseiSyrel 1/20/2015 00:58'!
newContentsBrick

	^ GTSpotterContentsBrick new! !

!GTSpotterPaneBrick methodsFor: 'instance creation' stamp: 'AliakseiSyrel 1/20/2015 01:13'!
newPreviewBrick

	^ GTSpotterPreviewBrick new! !

!GTSpotterPaneBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/20/2015 01:14'!
previewBrick

	^ previewBrick! !

!GTSpotterPaneBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/20/2015 01:14'!
previewBrick: aBrick

	previewBrick ifNotNil: [self removeBrick: aBrick].
	previewBrick := aBrick.
	
	self theme spotterWidgetThemer spotterPreviewStyleFor: previewBrick! !

!GTSpotterPaneBrick methodsFor: 'action' stamp: 'AliakseiSyrel 1/25/2015 22:19'!
showPreview
	
	self isPreviewShown ifTrue: [ ^ self ].
	
	self addBrickBack: self previewBrick.
	self previewBrick spotterModel ifNotNil: [
		self previewBrick updatePreviewWith: self previewBrick spotterModel currentStep selectedCandidate ].
	
	self contentsBrick layout horizontalPercent: (100 - self previewBrick layout horizontalPercent).
	self doLayout.
	self changed.! !

!GTSpotterPaneBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/25/2015 19:20'!
spotterModel: aSpotter

	self contentsBrick spotterModel: aSpotter.
	self arrowBrick spotterModel: aSpotter.
	self previewBrick spotterModel: aSpotter! !

GLMBrick subclass: #GTSpotterPreviewArrowBrick
	instanceVariableNames: 'triangleBrick selectedItemBrick spotterModel selfBounds'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-UI'!

!GTSpotterPreviewArrowBrick methodsFor: 'brick-layout' stamp: 'AliakseiSyrel 1/25/2015 21:34'!
doLayout
	super doLayout.
	
	selfBounds := nil.! !

!GTSpotterPreviewArrowBrick methodsFor: 'actions' stamp: 'AliakseiSyrel 1/25/2015 19:43'!
hideTriangle

	self triangleBrick color: Color transparent.
	self changed! !

!GTSpotterPreviewArrowBrick methodsFor: 'initialization' stamp: 'AliakseiSyrel 1/25/2015 19:00'!
initialize
	super initialize.
	
	self triangleBrick: self newTriangleBrick! !

!GTSpotterPreviewArrowBrick methodsFor: 'actions' stamp: 'AliakseiSyrel 1/25/2015 21:36'!
moveTo: anItemBrick
	|itemBounds delta|
	anItemBrick ifNil: [ ^ self ].
	
	itemBounds := anItemBrick globalBounds.
	delta := ((itemBounds top - self selfBounds top) max: 0) min: (self selfBounds height - self triangleBrick height).
	self triangleBrick brickBounds top = delta ifTrue: [ ^ self ].
	
	self triangleBrick translateY: (delta - self triangleBrick brickBounds top).
	self changed
	! !

!GTSpotterPreviewArrowBrick methodsFor: 'instance creation' stamp: 'AliakseiSyrel 1/25/2015 20:10'!
newTriangleBrick

	^ GLMActionButtonBrick new! !

!GTSpotterPreviewArrowBrick methodsFor: 'event handling' stamp: 'AliakseiSyrel 1/25/2015 20:26'!
onAllCandidatesRemoved

	self selectedItemBrick: nil! !

!GTSpotterPreviewArrowBrick methodsFor: 'event handling' stamp: 'AliakseiSyrel 1/25/2015 19:39'!
onCandidateMoved
	
	self moveTo: self selectedItemBrick! !

!GTSpotterPreviewArrowBrick methodsFor: 'event handling' stamp: 'AliakseiSyrel 1/25/2015 23:49'!
onCandidateSelected: ann

	self selectedItemBrick: ann candidateBrick.
	self moveTo: self selectedItemBrick.
	self brickRoot changed! !

!GTSpotterPreviewArrowBrick methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 1/26/2015 16:04'!
onDraw: aCanvas
	super onDraw: aCanvas.
	
		aCanvas
			fillRectangle: ((self brickBounds withWidth: self theme spotterWidgetThemer outerBorderWidth) translateBy: (self themer scrollbarWidth + self themer scrollbarOffset + 1)@0)
			color: (self spotterModel isPreviewVisible
				ifTrue: [ self theme spotterWidgetThemer backgroundColor ]
				ifFalse: [ Color transparent ])
	
	! !

!GTSpotterPreviewArrowBrick methodsFor: 'event handling' stamp: 'AliakseiSyrel 1/26/2015 15:59'!
onHidePreview

	self changed! !

!GTSpotterPreviewArrowBrick methodsFor: 'event handling' stamp: 'AliakseiSyrel 1/26/2015 15:59'!
onShowPreview

	self changed! !

!GTSpotterPreviewArrowBrick methodsFor: 'event handling' stamp: 'AliakseiSyrel 1/25/2015 20:26'!
onStepAdded
	
	self selectedItemBrick: nil.
	self spotterModel steps last candidates announcer subscribe: GTSpotterAllCandidatesRemoved send: #onAllCandidatesRemoved to: self.! !

!GTSpotterPreviewArrowBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/25/2015 19:37'!
selectedItemBrick
	
	^ selectedItemBrick! !

!GTSpotterPreviewArrowBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/25/2015 19:43'!
selectedItemBrick: aBrick
	
	selectedItemBrick isNil & aBrick isNotNil ifTrue: [ self showTriangle ].
	selectedItemBrick isNotNil & aBrick isNil ifTrue: [ self hideTriangle ].
	
	selectedItemBrick := aBrick! !

!GTSpotterPreviewArrowBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/25/2015 21:34'!
selfBounds

	^ selfBounds ifNil: [ selfBounds := self globalBounds ]! !

!GTSpotterPreviewArrowBrick methodsFor: 'actions' stamp: 'AliakseiSyrel 1/25/2015 19:43'!
showTriangle

	self triangleBrick color: self theme spotterWidgetThemer previewArrowColor.
	self changed! !

!GTSpotterPreviewArrowBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/25/2015 20:10'!
spotterModel

	^ spotterModel! !

!GTSpotterPreviewArrowBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/27/2015 10:59'!
spotterModel: aSpotterModel

	spotterModel := aSpotterModel.
	
	self spotterModel announcer weak subscribe: GTSpotterCandidateSelected send: #onCandidateSelected: to: self.
	self spotterModel announcer weak subscribe: GTSpotterCandidateSelectedMoved send: #onCandidateMoved to: self.
	self spotterModel announcer weak subscribe: GTSpotterStepAdded send: #onStepAdded to: self.
	self spotterModel announcer weak subscribe: GTSpotterShowPreview send: #onShowPreview to: self.
	self spotterModel announcer weak subscribe: GTSpotterHidePreview send: #onHidePreview to: self! !

!GTSpotterPreviewArrowBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/25/2015 18:58'!
triangleBrick

	^ triangleBrick! !

!GTSpotterPreviewArrowBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/26/2015 15:53'!
triangleBrick: aBrick

	triangleBrick := aBrick.
	self triangleBrick addUpAction: [ self spotterModel togglePreview ].
	self theme spotterWidgetThemer spotterPreviewArrowStyleFor: self triangleBrick.
	self addBrickBack: self triangleBrick
	! !

GLMBrick subclass: #GTSpotterPreviewBrick
	instanceVariableNames: 'compositeBrick spotterModel asyncTask'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-UI'!

!GTSpotterPreviewBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/27/2015 11:41'!
asyncTask

	^ asyncTask ifNil: [ asyncTask := GTAsyncTask new ]! !

!GTSpotterPreviewBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/20/2015 12:45'!
compositeBrick

	^ compositeBrick! !

!GTSpotterPreviewBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/28/2015 10:40'!
compositeBrick: aBrick

	self compositeBrick ifNotNil: [ self removeBrick: self compositeBrick ].
	compositeBrick := aBrick.
	self theme spotterWidgetThemer spotterPreviewCompositeStyleFor: compositeBrick.
	self addBrickBack: compositeBrick! !

!GTSpotterPreviewBrick methodsFor: 'initialization' stamp: 'AliakseiSyrel 1/20/2015 12:50'!
initialize
	super initialize.
	
	self compositeBrick: self newCompositeBrick! !

!GTSpotterPreviewBrick methodsFor: 'instance creation' stamp: 'AliakseiSyrel 1/20/2015 12:47'!
newCompositeBrick

	^ GLMCompositeBrick new! !

!GTSpotterPreviewBrick methodsFor: 'event handling' stamp: 'AliakseiSyrel 1/20/2015 13:18'!
onCandidateSelected: ann

	self updatePreviewWith: ann selected! !

!GTSpotterPreviewBrick methodsFor: 'event handling' stamp: 'AliakseiSyrel 1/20/2015 13:21'!
onStepPopped

	self updatePreviewWith: self spotterModel steps last selectedCandidate! !

!GTSpotterPreviewBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/20/2015 13:18'!
spotterModel

	^ spotterModel! !

!GTSpotterPreviewBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/27/2015 10:59'!
spotterModel: aSpotter
	
	spotterModel := aSpotter.
	aSpotter announcer weak subscribe: GTSpotterSelectedCandidateChanged send: #onCandidateSelected: to: self.
	aSpotter announcer weak subscribe: GTSpotterStepPopped send: #onStepPopped to: self
	! !

!GTSpotterPreviewBrick methodsFor: 'updating' stamp: 'TudorGirba 1/28/2015 12:59'!
updatePreviewWith: anObject

	self spotterModel isPreviewVisible ifFalse: [ ^ self ].
	
	self asyncTask
		execute: [ :composite :entity |
				[ anObject spotterPreviewIn: composite inContext: self spotterModel ]
					on: Exception
					do: [ composite removeAllBricks ].
				 composite ]
		withArguments: { self newCompositeBrick . anObject }
		callback: [ :composite |
			self compositeBrick: composite.
			self doLayout.
			self changed ]
		priority: Processor userBackgroundPriority! !

GLMBrick subclass: #GTSpotterStepBreadcrumbItem
	instanceVariableNames: 'labelBrick triangleBrick'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-UI'!

!GTSpotterStepBreadcrumbItem methodsFor: 'actions' stamp: 'AliakseiSyrel 1/25/2015 15:39'!
hideTriangle

	self triangleBrick color: Color transparent! !

!GTSpotterStepBreadcrumbItem methodsFor: 'initialization' stamp: 'AliakseiSyrel 1/25/2015 14:14'!
initialize
	super initialize.
	
	self
		layout: GLMBrickVerticalFillProportionalLinearLayout new;
		labelBrick: self newLabelBrick;
		triangleBrick: self newTriangleBrick
	! !

!GTSpotterStepBreadcrumbItem methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/25/2015 13:25'!
labelBrick

	^ labelBrick! !

!GTSpotterStepBreadcrumbItem methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/25/2015 14:11'!
labelBrick: aBrick

	labelBrick := aBrick.
	
	self theme spotterWidgetThemer breadcrumbItemLabelStyleFor: self labelBrick.
	self addBrickBack: self labelBrick! !

!GTSpotterStepBreadcrumbItem methodsFor: 'instance creation' stamp: 'AliakseiSyrel 1/25/2015 14:14'!
newLabelBrick

	^ GLMLabelBrick new! !

!GTSpotterStepBreadcrumbItem methodsFor: 'instance creation' stamp: 'AliakseiSyrel 1/25/2015 14:14'!
newTriangleBrick

	^ GLMBrick new! !

!GTSpotterStepBreadcrumbItem methodsFor: 'actions' stamp: 'AliakseiSyrel 1/25/2015 15:39'!
showTriangle

	self triangleBrick color: self theme spotterWidgetThemer breadcrumbItemBackgroundColor! !

!GTSpotterStepBreadcrumbItem methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/25/2015 14:13'!
text: aString

	self labelBrick text: aString! !

!GTSpotterStepBreadcrumbItem methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/25/2015 14:09'!
triangleBrick

	^ triangleBrick! !

!GTSpotterStepBreadcrumbItem methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/25/2015 15:38'!
triangleBrick: aBrick

	triangleBrick := aBrick.
	
	self theme spotterWidgetThemer breadcrumbItemTriangleStyleFor: self triangleBrick.
	self addBrickBack: self triangleBrick! !

GLMBrick subclass: #GTSpotterStepsBreadcrumb
	instanceVariableNames: 'spotterModel items band'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-UI'!

!GTSpotterStepsBreadcrumb methodsFor: 'adding/removing' stamp: 'AliakseiSyrel 1/26/2015 00:55'!
addItem: aBrick

	self items size = 1 ifTrue: [
		self items first labelBrick layout paddingLeft: self theme spotterWidgetThemer breadcrumbSeparatorWidth / 2 ].
	self band addBrickBack: aBrick.
	self items addLast: aBrick! !

!GTSpotterStepsBreadcrumb methodsFor: 'adding/removing' stamp: 'AliakseiSyrel 1/26/2015 00:24'!
addSeparator
	|separator|
	separator := self newSeparator.
	self theme spotterWidgetThemer breadcrumbSeparatorStyleFor: separator.
	self band addBrickBack: separator! !

!GTSpotterStepsBreadcrumb methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/20/2014 14:12'!
band

	^ band! !

!GTSpotterStepsBreadcrumb methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/26/2015 00:20'!
band: aBrick

	band := aBrick.
	band layoutPolicy: (GLMBrickHorizontalFillLinearLayout new).
	band width: [ :bandBrick |
		self items isEmpty ifTrue: [ 0 ]
			ifFalse: [ |width|
				width := 0.
				self items do: [ :each | width := width + each width ].
				width + ((self items size - 1) * self theme spotterWidgetThemer breadcrumbSeparatorWidth)] ].
	
	self band data: 0.
	self addBrickBack: band.! !

!GTSpotterStepsBreadcrumb methodsFor: 'geometry' stamp: 'AliakseiSyrel 1/26/2015 00:14'!
calculateItemWidth: aBrick
	|sWidth bWidth|
	sWidth := self theme spotterWidgetThemer breadcrumbSeparatorWidth.
	bWidth := self width.
	
	"width of other bricks depends from the width of the last one"
	^ aBrick isLastInOwner
		ifTrue: [ ((aBrick labelBrick approximateWidth min: (bWidth / 2)) max: ((bWidth - ((self maxNumberOfSteps - 1) * sWidth)) / self maxNumberOfSteps)) floor ]
		ifFalse: [ ((bWidth - self band lastSubbrick width - ((self maxNumberOfSteps - 1) * sWidth)) / (self maxNumberOfSteps - 1)) floor ]
	! !

!GTSpotterStepsBreadcrumb methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/25/2015 14:21'!
defaultBreadcrumbHeight

	^ self theme spotterWidgetThemer breadcrumbHeight + self theme spotterWidgetThemer breadcrumbTriangleHeight! !

!GTSpotterStepsBreadcrumb methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 1/27/2015 09:36'!
doLayout
	super doLayout.
	
	self scrollToTheLastOne: false! !

!GTSpotterStepsBreadcrumb methodsFor: 'geometry' stamp: 'AliakseiSyrel 12/10/2014 15:03'!
glmAnimateBrickBounds: aValue duration: anInteger callback: aBlock

	anInteger <= 0
		"if duration is zero, move to the left immediately"
		ifTrue: [ self leftTo: aValue ]
		ifFalse: [
			| startTime start currentValue startBounds|
			currentValue := 0.
			startBounds := self band brickBounds.
			startTime := Time millisecondClockValue.
			start := currentValue.
			[	| delta translate|
				[ (delta := Time millisecondClockValue - startTime) < anInteger ] whileTrue: [
					translate := (aValue - start) * (delta / anInteger) + start.
					self band brickBounds: (startBounds translateBy: translate@0).
					self changed.
					Processor yield
				].
				self band brickBounds: (startBounds translateBy: aValue@0).
				self changed.
				Processor yield.
				aBlock ifNotNil: [ aBlock value ].
			] fork
		]! !

!GTSpotterStepsBreadcrumb methodsFor: 'initialization' stamp: 'AliakseiSyrel 1/27/2015 09:18'!
initialize
	super initialize.
	
	self
		layout: GLMBrickHorizontalFillLinearLayout new;
		band: self newBand;
		height: [ self items isEmpty ifTrue: [ 0 ] ifFalse: [ self defaultBreadcrumbHeight ] ]
	! !

!GTSpotterStepsBreadcrumb methodsFor: 'testing' stamp: 'AliakseiSyrel 11/21/2014 00:55'!
isVisible

	^ self items isEmpty not! !

!GTSpotterStepsBreadcrumb methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/20/2014 13:28'!
items

	^ items ifNil: [ items := OrderedCollection new ]! !

!GTSpotterStepsBreadcrumb methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/20/2014 11:47'!
maxNumberOfSteps
	^ 5! !

!GTSpotterStepsBreadcrumb methodsFor: 'instance creation' stamp: 'AliakseiSyrel 11/20/2014 14:13'!
newBand

	^ GLMBrick new! !

!GTSpotterStepsBreadcrumb methodsFor: 'instance creation' stamp: 'AliakseiSyrel 1/26/2015 00:22'!
newSeparator

	^ GLMBrick new! !

!GTSpotterStepsBreadcrumb methodsFor: 'notifying' stamp: 'TudorGirba 11/26/2014 14:35'!
notifyBreadcrumbVisibilityChanged

	self announcer announce: GTSpotterBreadcrumbVisibilityChanged new! !

!GTSpotterStepsBreadcrumb methodsFor: 'events-processing' stamp: 'AliakseiSyrel 1/26/2015 15:42'!
onStepAdded: ann
	|step origin previousStep selectedCandidate|
	
	self spotterModel steps size <= 1 ifTrue: [ ^ self push: (GTSpotterStepBreadcrumbItem new text: 'Spotter') ].
	
	step := ann stepModel.
	previousStep := (step spotter steps at: step spotter steps size - 1).
	selectedCandidate := previousStep selectedCandidate.
	origin := step origin.
	
	self push: (GTSpotterStepBreadcrumbItem new
		text: ((selectedCandidate = origin)
			ifTrue: [ (previousStep selected renderingProcessor render: selectedCandidate) labelBrick text ]
			ifFalse: [ (origin isKindOf: Collection) ifTrue: [ previousStep selected processor title ] ifFalse: [ origin gtDisplayString] ]))! !

!GTSpotterStepsBreadcrumb methodsFor: 'events-processing' stamp: 'AliakseiSyrel 11/20/2014 13:39'!
onStepPopped

	self pop
	! !

!GTSpotterStepsBreadcrumb methodsFor: 'adding/removing' stamp: 'AliakseiSyrel 1/27/2015 09:36'!
pop

	self band removeBrick: self items last.
	self items removeLast.
	
	self items size = 1 ifTrue: [
		self items first labelBrick layout paddingLeft: 0 ].
	
	self items isEmpty ifFalse: [ self popSeparator ].
	
	"optimization. if last item was popped we need to update root to reposition all brick,
	otherwise only I need to be updated"
	self items size = 0
		ifTrue: [ self notifyBreadcrumbVisibilityChanged ]
		ifFalse: [
			self items last showTriangle.
			super doLayout.
			self scrollToTheLastOne.
			self changed ]! !

!GTSpotterStepsBreadcrumb methodsFor: 'adding/removing' stamp: 'AliakseiSyrel 1/26/2015 00:09'!
popSeparator

	self band removeBrick: self band lastSubbrick! !

!GTSpotterStepsBreadcrumb methodsFor: 'adding/removing' stamp: 'AliakseiSyrel 1/27/2015 09:36'!
push: aBrick

	self theme spotterWidgetThemer breadcrumbItemStyleFor: aBrick.
	
	aBrick width: [ :itemBrick | self calculateItemWidth: itemBrick ].
	
	self items isEmpty ifFalse: [
		self items last hideTriangle.
		self addSeparator ].
	
	self addItem: aBrick.
	
	"optimization. if first item was added we need to update root to reposition all bricks,
	otherwise only I need to be updated"
	self items size = 1
		ifTrue: [ self notifyBreadcrumbVisibilityChanged ]
		ifFalse: [
			super doLayout.
			self scrollToTheLastOne.
			self changed ].
	! !

!GTSpotterStepsBreadcrumb methodsFor: 'geometry' stamp: 'AliakseiSyrel 1/27/2015 09:35'!
scrollToTheLastOne

	self scrollToTheLastOne: true
	
	! !

!GTSpotterStepsBreadcrumb methodsFor: 'geometry' stamp: 'AliakseiSyrel 1/27/2015 09:35'!
scrollToTheLastOne: isAnimated
	|leftDelta rightDelta delta|
	self items isEmpty ifTrue: [ ^ self ].
	
	self band translateX: self band data.
	
	rightDelta := self globalBounds right - self band globalBounds right.
	leftDelta := self globalBounds left - self band globalBounds left.
			
	"all visible, return"
	(leftDelta = 0  and: [ self items size <= self maxNumberOfSteps ]) ifTrue: [ ^ self ].
	
	delta := (self items size <= self maxNumberOfSteps) ifTrue: [leftDelta] ifFalse: [rightDelta].
	self band data: (self band data + delta).

	isAnimated ifFalse: [ ^ self band translateX: delta ].
	
	self
		glmAnimateBrickBounds: delta
		duration: 400
		callback: nil.
	
	! !

!GTSpotterStepsBreadcrumb methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/15/2014 20:38'!
spotterModel
	^ spotterModel! !

!GTSpotterStepsBreadcrumb methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/27/2015 10:58'!
spotterModel: aSpotterModel
	
	spotterModel := aSpotterModel.
	
	spotterModel announcer weak subscribe: GTSpotterStepAdded send: #onStepAdded: to: self.
	spotterModel announcer weak subscribe: GTSpotterStepPopped send: #onStepPopped to: self.! !

GLMBrickDarkThemer subclass: #GTSpotterBrickDarkThemer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Theme'!

!GTSpotterBrickDarkThemer methodsFor: 'brick-scrollbar' stamp: 'AliakseiSyrel 1/26/2015 15:01'!
scrollbarColor

	^ Color black alpha: 0.5! !

!GTSpotterBrickDarkThemer methodsFor: 'brick-scrollpane' stamp: 'AliakseiSyrel 1/26/2015 15:26'!
scrollpaneBackgroundColor

	^ Color r: 0.3 g: 0.3 b: 0.3! !

!DoubleLink methodsFor: '*GT-Spotter' stamp: 'TudorGirba 11/26/2014 14:35'!
asSpotterDoubleLink
	
	^ GTSpotterCandidateLink value: self value! !

DoubleLink subclass: #GTSpotterCandidateLink
	instanceVariableNames: 'processorLink weight renderingProcessorLink'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Utils'!

!GTSpotterCandidateLink methodsFor: 'comparing' stamp: 'AliakseiSyrel 11/24/2014 18:11'!
< anotherCandidateLink

	^ self weight < anotherCandidateLink weight! !

!GTSpotterCandidateLink methodsFor: 'comparing' stamp: 'AliakseiSyrel 11/24/2014 18:10'!
> anotherCandidateLink

	^ self weight > anotherCandidateLink weight! !

!GTSpotterCandidateLink methodsFor: 'converting' stamp: 'AliakseiSyrel 11/24/2014 18:48'!
asSpotterCandidateLink

	^ self! !

!GTSpotterCandidateLink methodsFor: 'copying' stamp: 'AliakseiSyrel 12/20/2014 19:04'!
copy
	|link|
	link := self class value: self value.
	link privateProcessorLink: processorLink.
	link privateRenderingProcessorLink: renderingProcessorLink.
	link weight: weight.
	^ link! !

!GTSpotterCandidateLink methodsFor: 'private' stamp: 'AliakseiSyrel 12/20/2014 18:49'!
privateProcessorLink: aLink

	processorLink := aLink! !

!GTSpotterCandidateLink methodsFor: 'private' stamp: 'AliakseiSyrel 12/20/2014 18:49'!
privateRenderingProcessorLink: aLink

	renderingProcessorLink := aLink! !

!GTSpotterCandidateLink methodsFor: 'accessing' stamp: 'AliakseiSyrel 12/11/2014 00:10'!
processor

	^ self processorLink value! !

!GTSpotterCandidateLink methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/24/2014 18:32'!
processorLink
	^ processorLink! !

!GTSpotterCandidateLink methodsFor: 'accessing' stamp: 'AliakseiSyrel 12/20/2014 18:29'!
processorLink: anObject

	"we set rendering processor only if one is not set. it allows to have a collection of items,
	that have different rendering processors"
	
	processorLink ifNil: [ self renderingProcessor: anObject ].
	processorLink := anObject.
	! !

!GTSpotterCandidateLink methodsFor: 'accessing' stamp: 'AliakseiSyrel 12/20/2014 18:36'!
renderingProcessor

	renderingProcessorLink ifNil: [ self renderingProcessor: processorLink ].
	^ renderingProcessorLink value! !

!GTSpotterCandidateLink methodsFor: 'accessing' stamp: 'AliakseiSyrel 12/20/2014 18:40'!
renderingProcessor: aProcessorLink

	renderingProcessorLink ifNil: [ renderingProcessorLink := aProcessorLink processor asSpotterProcessorLink ].
	processorLink ifNil: [ processorLink := aProcessorLink ]! !

!GTSpotterCandidateLink methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/24/2014 18:10'!
weight

	^ weight! !

!GTSpotterCandidateLink methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/24/2014 18:11'!
weight: anObject 

	weight := anObject! !

DoubleLink subclass: #GTSpotterProcessorLink
	instanceVariableNames: 'headLink tailLink size'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Utils'!

!GTSpotterProcessorLink class methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/24/2014 18:41'!
from: aDoubleLink

	! !

!GTSpotterProcessorLink methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/24/2014 18:48'!
asSpotterProcessorLink

	^ self! !

!GTSpotterProcessorLink methodsFor: 'actions' stamp: 'AliakseiSyrel 11/24/2014 22:29'!
clear

	self
		headLink: nil;
		tailLink: nil.
		
	size := 0.! !

!GTSpotterProcessorLink methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/24/2014 19:30'!
headLink
	^ headLink! !

!GTSpotterProcessorLink methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/24/2014 19:30'!
headLink: anObject
	headLink := anObject! !

!GTSpotterProcessorLink methodsFor: 'actions' stamp: 'AliakseiSyrel 11/24/2014 22:29'!
incrementSize

	size := self size + 1! !

!GTSpotterProcessorLink methodsFor: 'testing' stamp: 'AliakseiSyrel 11/24/2014 20:29'!
isEmpty

	^ self headLink isNil! !

!GTSpotterProcessorLink methodsFor: 'testing' stamp: 'AliakseiSyrel 11/24/2014 22:33'!
isFull

	^ self size = self processor candidatesLimit! !

!GTSpotterProcessorLink methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/24/2014 18:40'!
processor

	^ self value! !

!GTSpotterProcessorLink methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/24/2014 22:29'!
size

	^ size ifNil: [ size := 0 ]! !

!GTSpotterProcessorLink methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/24/2014 19:30'!
tailLink
	^ tailLink! !

!GTSpotterProcessorLink methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/24/2014 19:30'!
tailLink: anObject
	tailLink := anObject! !

KMCategory subclass: #GTSpotterGlobalShortcut
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-UI'!

GTSpotterGlobalShortcut class
	instanceVariableNames: 'globalSpotter'!

!GTSpotterGlobalShortcut commentStamp: 'TudorGirba 11/18/2014 02:57' prior: 0!
KMRepository reset!

GTSpotterGlobalShortcut class
	instanceVariableNames: 'globalSpotter'!

!GTSpotterGlobalShortcut class methodsFor: 'testing' stamp: 'TudorGirba 11/17/2014 22:30'!
isGlobalCategory
	^ true! !

!GTSpotterGlobalShortcut class methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/20/2015 01:36'!
openGlobalSpotter
	globalSpotter 
		ifNotNil: [ globalSpotter delete ].
		
	globalSpotter := GTSpotterMorph new
		extent: (World width / 2.4 @ (World height / 1.6)) asIntegerPoint;
		spotterModel: GTSpotter new;
		openCenteredInWorld.
		
	^ globalSpotter! !

!GTSpotterGlobalShortcut class methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/27/2015 09:53'!
openGlobalSpotterDebug
	<example>
	globalSpotter 
		ifNotNil: [ globalSpotter delete ].
		
	globalSpotter := GTSpotterMorph new
		extent: 830@630;
		spotterModel: GTSpotter new;
		openInWindowLabeled: 'Spotter Debug Mode';
		showPreview.
		
	^ globalSpotter! !

!GTSpotterGlobalShortcut methodsFor: 'as yet unclassified' stamp: 'AndreiChis 1/9/2015 11:30'!
keymapToggle
	"KMRepository reset"
	<shortcut>
	^ KMKeymap
			shortcut: Character cr shift
			action: [ self class openGlobalSpotter ]! !

!GTSpotterGlobalShortcut methodsFor: 'as yet unclassified' stamp: 'AndreiChis 1/23/2015 16:31'!
keymapToggleDebug
	"KMRepository reset"
	"<shortcut>"
	^ KMKeymap
			shortcut: Character cr command
			action: [ self class openGlobalSpotterDebug ]! !

!GTSpotterGlobalShortcut methodsFor: 'as yet unclassified' stamp: 'TudorGirba 11/27/2014 07:06'!
openGlobalSpotter
	! !

GLMBandBrick subclass: #GTSpotterCategoryBrick
	instanceVariableNames: 'listBrick titleBrick stepModel category'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-UI'!

!GTSpotterCategoryBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/14/2014 23:11'!
category

	^ category! !

!GTSpotterCategoryBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/14/2014 23:14'!
category: aProcessorClass

	category := aProcessorClass! !

!GTSpotterCategoryBrick methodsFor: 'geometry' stamp: 'AliakseiSyrel 11/29/2014 14:53'!
height
	"instead of deleting brick when empty, just make it invisible"
	^ self subbricks isEmpty
		ifTrue: [ 0 ]
		ifFalse: [ super height ]! !

!GTSpotterCategoryBrick methodsFor: 'instance creation' stamp: 'AliakseiSyrel 11/29/2014 14:54'!
on: aStepModel category: aProcessor

	self stepModel: aStepModel.
	self category: aProcessor.! !

!GTSpotterCategoryBrick methodsFor: 'brick-structure-events' stamp: 'AliakseiSyrel 1/27/2015 10:51'!
onRemoved
	super onRemoved.
	
	self removeAllBricks! !

!GTSpotterCategoryBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 12/2/2014 16:00'!
setAmountVisible: visible all: all

	self titleBrick setAmountVisible: visible all: all! !

!GTSpotterCategoryBrick methodsFor: 'accessing' stamp: 'AliaskeiSyrel 11/13/2014 20:34'!
stepModel
	^ stepModel! !

!GTSpotterCategoryBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/14/2014 23:33'!
stepModel: anObject
	stepModel := anObject.! !

!GTSpotterCategoryBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/23/2014 18:39'!
titleBrick
	^ titleBrick! !

!GTSpotterCategoryBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/29/2014 14:24'!
titleBrick: aBrick

	titleBrick := aBrick! !

RubTextFieldMorph subclass: #GTSpotterSearchFieldMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-UI'!

!GTSpotterSearchFieldMorph methodsFor: 'geometry' stamp: 'AliakseiSyrel 1/25/2015 16:16'!
extent: aPoint
	super extent: aPoint.
	
	self owner ifNotNil: [
		"to center text area"
		self owner layoutProperties marginTop: (self theme spotterWidgetThemer headerHeight - self textArea height) / 2 ]! !

!GTSpotterSearchFieldMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 10/24/2014 10:50'!
getMenuSelector: aSymbol! !

!GTSpotterSearchFieldMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 11/15/2014 15:43'!
moveCursorAtTheEnd

	self moveCursorToIndex: (self text size + 1)! !

!GTSpotterSearchFieldMorph methodsFor: 'initialize-release' stamp: 'TudorGirba 11/26/2014 14:35'!
newScrollPane
	"using hacked ScrollPane to remove focus border"
	| sp |
	sp := GTSpotterSearchFieldScrollPane new.
	sp scrollTarget: self defaultScrollTarget.
	^ sp! !

Announcement subclass: #GTSpotterAllCandidatesAdded
	instanceVariableNames: 'candidateLinks category'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Announcements'!

!GTSpotterAllCandidatesAdded methodsFor: 'accessing' stamp: 'TudorGirba 11/28/2014 11:45'!
candidateLinks
	^ candidateLinks! !

!GTSpotterAllCandidatesAdded methodsFor: 'accessing' stamp: 'TudorGirba 11/28/2014 11:45'!
candidateLinks: anObject
	candidateLinks := anObject! !

!GTSpotterAllCandidatesAdded methodsFor: 'accessing' stamp: 'TudorGirba 11/28/2014 11:45'!
category
	^ category! !

!GTSpotterAllCandidatesAdded methodsFor: 'accessing' stamp: 'TudorGirba 11/28/2014 11:45'!
category: anObject
	category := anObject! !

Announcement subclass: #GTSpotterAllCandidatesRemoved
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Announcements'!

Announcement subclass: #GTSpotterBreadcrumbVisibilityChanged
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Announcements'!

Announcement subclass: #GTSpotterCandidateAdded
	instanceVariableNames: 'candidateLink category'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Announcements'!

!GTSpotterCandidateAdded methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/19/2014 00:12'!
candidate
	^ candidateLink value! !

!GTSpotterCandidateAdded methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/20/2015 13:13'!
candidateLink

	^ candidateLink! !

!GTSpotterCandidateAdded methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/19/2014 00:10'!
candidateLink: anObject
	candidateLink := anObject! !

!GTSpotterCandidateAdded methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/14/2014 21:35'!
category
	^ category! !

!GTSpotterCandidateAdded methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/14/2014 21:35'!
category: anObject
	category := anObject! !

Announcement subclass: #GTSpotterCandidateSelected
	instanceVariableNames: 'candidateBrick'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Announcements'!

!GTSpotterCandidateSelected methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/19/2014 15:35'!
candidateBrick
	^ candidateBrick! !

!GTSpotterCandidateSelected methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/19/2014 15:35'!
candidateBrick: anObject
	candidateBrick := anObject! !

Announcement subclass: #GTSpotterCandidateSelectedMoved
	instanceVariableNames: 'candidateBrick'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Announcements'!

!GTSpotterCandidateSelectedMoved methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/25/2015 19:31'!
candidateBrick
	^ candidateBrick! !

!GTSpotterCandidateSelectedMoved methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/25/2015 19:31'!
candidateBrick: anObject
	candidateBrick := anObject! !

Announcement subclass: #GTSpotterCandidatesAmountChanged
	instanceVariableNames: 'amount category'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Announcements'!

!GTSpotterCandidatesAmountChanged methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/19/2014 23:04'!
amount
	^ amount! !

!GTSpotterCandidatesAmountChanged methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/19/2014 23:04'!
amount: anObject
	amount := anObject! !

!GTSpotterCandidatesAmountChanged methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/19/2014 23:06'!
category
	^ category! !

!GTSpotterCandidatesAmountChanged methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/19/2014 23:06'!
category: anObject
	category := anObject! !

Announcement subclass: #GTSpotterCategoryDeselected
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Announcements'!

Announcement subclass: #GTSpotterCategorySelected
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Announcements'!

Announcement subclass: #GTSpotterCurrentStepChanged
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Announcements'!

Announcement subclass: #GTSpotterExitAnnouncement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Announcements'!

Announcement subclass: #GTSpotterHidePreview
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Announcements'!

Announcement subclass: #GTSpotterRequestNextStep
	instanceVariableNames: 'origin'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Announcements'!

!GTSpotterRequestNextStep methodsFor: 'accessing' stamp: 'AliaskeiSyrel 11/6/2014 11:51'!
origin
	^ origin! !

!GTSpotterRequestNextStep methodsFor: 'accessing' stamp: 'AliaskeiSyrel 11/6/2014 11:51'!
origin: anObject
	origin := anObject! !

Announcement subclass: #GTSpotterSelectedCandidateChanged
	instanceVariableNames: 'selected'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Announcements'!

!GTSpotterSelectedCandidateChanged methodsFor: 'accessing' stamp: 'AliaskeiSyrel 11/13/2014 20:20'!
selected
	^ selected! !

!GTSpotterSelectedCandidateChanged methodsFor: 'accessing' stamp: 'AliaskeiSyrel 11/13/2014 20:20'!
selected: anObject
	selected := anObject! !

Announcement subclass: #GTSpotterShowPreview
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Announcements'!

Announcement subclass: #GTSpotterStepAdded
	instanceVariableNames: 'stepModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Announcements'!

!GTSpotterStepAdded methodsFor: 'accessing' stamp: 'AliaskeiSyrel 11/6/2014 13:38'!
stepModel
	^ stepModel! !

!GTSpotterStepAdded methodsFor: 'accessing' stamp: 'AliaskeiSyrel 11/6/2014 13:38'!
stepModel: anObject
	stepModel := anObject! !

Announcement subclass: #GTSpotterStepPopped
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Announcements'!

!UITheme methodsFor: '*GT-Spotter' stamp: 'TudorGirba 11/26/2014 14:34'!
spotterWidgetThemer
	^ GTSpotterWidgetThemer new! !

DoubleLinkedList subclass: #GTSpotterDoubleLinkedList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Utils'!

!GTSpotterDoubleLinkedList methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/14/2014 14:48'!
head

	^ head! !

!GTSpotterDoubleLinkedList methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/14/2014 20:45'!
head: aDoubleLink

	head := aDoubleLink! !

!GTSpotterDoubleLinkedList methodsFor: 'enumerating' stamp: 'AliakseiSyrel 11/14/2014 14:48'!
linksDo: aBlock
	| current |
	current := head.
	[ current isNil ] 
		whileFalse: [ 
	 		aBlock value: current.
			current := current nextLink ]! !

!GTSpotterDoubleLinkedList methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 11/15/2014 13:59'!
removeCycledLink: link
	| predecessor successor |
	predecessor := link previousLink.
	successor := link nextLink.
	predecessor
		ifNil: [ head := successor ]
		ifNotNil: [ predecessor nextLink: successor ].
	successor
		ifNil: [ tail := predecessor ]
		ifNotNil: [ successor previousLink: predecessor ].
	link clearLinks.
	
	"I'm the only one left, clear linked list and return"
	(link = head & (link = tail)) ifTrue: [ head := nil. tail := nil. ^ link ].
	
	link = head ifTrue: [ head := successor ].
	link = tail ifTrue: [ tail := predecessor ].
	
	^ link! !

!GTSpotterDoubleLinkedList methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/14/2014 14:48'!
tail

	^ tail! !

!GTSpotterDoubleLinkedList methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/14/2014 20:45'!
tail: aDoubleLink

	tail := aDoubleLink! !

GLMBrickRenderer subclass: #GTSpotterBreadcrumbSeparatorRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Renderer'!

!GTSpotterBreadcrumbSeparatorRenderer methodsFor: 'rendering' stamp: 'AliakseiSyrel 1/26/2015 00:26'!
render: aBrick on: aCanvas
	super renderBackgroundColorOf: aBrick on: aCanvas.
	
	self renderArrow: aBrick on: aCanvas! !

!GTSpotterBreadcrumbSeparatorRenderer methodsFor: 'rendering' stamp: 'AliakseiSyrel 1/26/2015 00:50'!
renderArrow: aBrick on: aCanvas
	|height width hW hH aX bX cX aY bY cY a b c overdraw delta|
	
	overdraw := 2.
	delta := 1.
	height := aBrick brickBounds height.
	width := aBrick brickBounds width.
	hH := height / 4.
	hW := width / 2.
	
	aX := (((hW - hH) max: 0) min: width) floor - overdraw - delta.
	bX := (((hW + hH) max: 0) min: width) floor - delta.
	cX := aX.
	
	aY := overdraw negated.
	bY := (hH * 2) floor.
	cY := height + overdraw.
	
	a := aBrick brickBounds topLeft + (aX@aY).
	b := aBrick brickBounds topLeft + (bX@bY).
	c := aBrick brickBounds topLeft + (cX@cY).
	
	aCanvas line: a to: b width: aBrick borderWidth color: aBrick borderColor.
	aCanvas line: b to: c width: aBrick borderWidth color: aBrick borderColor! !

GLMBrickRenderer subclass: #GTSpotterTriangleRenderer
	instanceVariableNames: 'orientation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Renderer'!

!GTSpotterTriangleRenderer methodsFor: 'mathematical functions' stamp: 'AliakseiSyrel 1/25/2015 13:48'!
findTriangleEdgeLength: anInteger

	^ 2 / 3 * (3 sqrt) * anInteger! !

!GTSpotterTriangleRenderer methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/25/2015 13:34'!
orientation
	^ orientation ifNil: [ #bottom ]! !

!GTSpotterTriangleRenderer methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/25/2015 13:34'!
orientation: aSymbol
	"can be #right #bottom #left #top"

	orientation := aSymbol! !

!GTSpotterTriangleRenderer methodsFor: 'rendering' stamp: 'AliakseiSyrel 1/25/2015 16:52'!
render: aBrick on: aCanvas
	
	self orientation = #right ifTrue: [ self renderRightTriangle: aBrick on: aCanvas ].
	self orientation = #bottom ifTrue: [ self renderBottomTriangle: aBrick on: aCanvas ].
	self orientation = #left ifTrue: [ self renderLeftTriangle: aBrick on: aCanvas ].
	self orientation = #top ifTrue: [ self renderTopTriangle: aBrick on: aCanvas ].! !

!GTSpotterTriangleRenderer methodsFor: 'rendering' stamp: 'AliakseiSyrel 1/25/2015 19:05'!
renderBottomTriangle: aBrick on: aCanvas
	|a b c width height|
	
	width := aBrick brickBounds width.
	height := aBrick brickBounds height.
	
	a := aBrick brickBounds topLeft + (((width / 2 - height) max: 0) @ 0).
	b := aBrick brickBounds topLeft + (((width / 2 + height) min: width) @ 0).
	c := aBrick brickBounds bottomLeft + (width / 2 @ 0).
	
	self renderTriangle: aBrick on: aCanvas with: { a asIntegerPoint . b asIntegerPoint . c asIntegerPoint}! !

!GTSpotterTriangleRenderer methodsFor: 'rendering' stamp: 'AliakseiSyrel 1/25/2015 19:07'!
renderLeftTriangle: aBrick on: aCanvas
	|a b c width height|
	
	width := aBrick brickBounds width.
	height := aBrick brickBounds height.
	
	a := aBrick brickBounds topRight + (0 @ ((height / 2 - width) max: 0)).
	b := aBrick brickBounds topRight + (0 @ ((height / 2 + width) min: height)).
	c := aBrick brickBounds topLeft + (0 @ (height / 2)).
	
	self renderTriangle: aBrick on: aCanvas with: { a asIntegerPoint . b asIntegerPoint . c asIntegerPoint}! !

!GTSpotterTriangleRenderer methodsFor: 'rendering' stamp: 'AliakseiSyrel 1/25/2015 23:43'!
renderRightTriangle: aBrick on: aCanvas
	|a b c width height gap|
	
	gap := aBrick theme spotterWidgetThemer previewArrowGapHack.
	aCanvas fillRectangle: (aBrick brickBounds withWidth: gap) color: aBrick color.
	
	width := aBrick brickBounds width - gap.
	height := aBrick brickBounds height.
	
	a := aBrick brickBounds topLeft + (gap @ ((height / 2 - width) max: 0)).
	b := aBrick brickBounds topLeft + (gap @ ((height / 2 + width) min: height)).
	c := aBrick brickBounds topRight + (0 @ (height / 2)).
	
	self renderTriangle: aBrick on: aCanvas with: { a asIntegerPoint . b asIntegerPoint . c asIntegerPoint}! !

!GTSpotterTriangleRenderer methodsFor: 'rendering' stamp: 'AliakseiSyrel 1/25/2015 19:06'!
renderTopTriangle: aBrick on: aCanvas
	|a b c width height|
	
	width := aBrick brickBounds width.
	height := aBrick brickBounds height.
	
	a := aBrick brickBounds bottomLeft + (((width / 2 - height) max: 0) @ 0).
	b := aBrick brickBounds bottomLeft + (((width / 2 + height) min: width) @ 0).
	c := aBrick brickBounds topLeft + (width / 2 @ 0).
	
	self renderTriangle: aBrick on: aCanvas with: { a asIntegerPoint . b asIntegerPoint . c asIntegerPoint}! !

!GTSpotterTriangleRenderer methodsFor: 'rendering' stamp: 'AliakseiSyrel 1/25/2015 13:56'!
renderTriangle: aBrick on: aCanvas with: aCollection

	aCanvas drawPolygon: aCollection color: aBrick color borderWidth: 0 borderColor: Color transparent! !

GLMFoundationBrick subclass: #GTSpotterMorph
	instanceVariableNames: 'focusedMorph breadcrumbBrick paneBrick spotterModel autoHide'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-UI'!

!GTSpotterMorph methodsFor: 'actions' stamp: 'AliakseiSyrel 11/21/2014 13:53'!
act
	self spotterModel isEmpty ifTrue: [ ^self ].
	self spotterModel currentStep isEmpty ifTrue: [ ^ self ].
	self spotterModel currentStep act! !

!GTSpotterMorph methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/19/2015 20:46'!
autoHide

	^ autoHide ifNil: [ autoHide := true ]! !

!GTSpotterMorph methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/19/2015 20:47'!
autoHide: aBoolean

	autoHide := aBoolean! !

!GTSpotterMorph methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/20/2014 11:49'!
breadcrumbBrick
	
	^ breadcrumbBrick! !

!GTSpotterMorph methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/27/2015 09:32'!
breadcrumbBrick: aBrick

	breadcrumbBrick ifNotNil: [self removeBrick: breadcrumbBrick].
	breadcrumbBrick := aBrick.
	
	breadcrumbBrick announcer subscribe: GTSpotterBreadcrumbVisibilityChanged send: #onBreadcrumbVisibilityChanged to: self.
	self theme spotterWidgetThemer breadcrumbStyleFor: breadcrumbBrick.
	breadcrumbBrick width: [ self paneBrick contentsBrick width ].
	self addBrickBack: breadcrumbBrick! !

!GTSpotterMorph methodsFor: 'actions' stamp: 'TudorGirba 11/26/2014 22:20'!
diveIn

	self spotterModel isEmpty ifFalse: [ 
		self spotterModel currentStep isEmpty ifFalse: [ 
			self spotterModel currentStep diveIn ] ]! !

!GTSpotterMorph methodsFor: 'actions' stamp: 'TudorGirba 11/20/2014 21:57'!
diveInCategory

	self spotterModel isEmpty
		ifFalse: [ self spotterModel currentStep isEmpty ifFalse: [ self spotterModel currentStep diveInCategory ] ]! !

!GTSpotterMorph methodsFor: 'actions' stamp: 'AliakseiSyrel 11/15/2014 15:57'!
diveOut

	self spotterModel popStep! !

!GTSpotterMorph methodsFor: 'actions' stamp: 'AliakseiSyrel 1/28/2015 10:32'!
escapePressed

	self autoHide ifTrue: [ self delete ]! !

!GTSpotterMorph methodsFor: 'events-processing' stamp: 'AliakseiSyrel 1/19/2015 20:47'!
handleListenEvent: anEvent
		
	anEvent type = #mouseDown ifTrue: [ 
		((self fullBoundsInWorld containsPoint: anEvent position) not and: [ self autoHide ])
			ifTrue: [ self delete ] ].
		
	anEvent type = #keyDown ifTrue: [
		anEvent keyValue = 56 ifTrue: [ self shiftPressed ]	]! !

!GTSpotterMorph methodsFor: 'event handling' stamp: 'AliakseiSyrel 10/23/2014 19:58'!
handlesMouseDown: evt
	^ true! !

!GTSpotterMorph methodsFor: 'actions' stamp: 'AliakseiSyrel 1/26/2015 15:54'!
hidePreview
	
	self spotterModel hidePreview! !

!GTSpotterMorph methodsFor: 'initialization' stamp: 'AliakseiSyrel 1/26/2015 14:12'!
initialize
	super initialize.
	"setting custom brick themer for the whole spotter"
	self themer: self theme spotterWidgetThemer brickThemer.
	
	self initializeListeners.
	self theme spotterWidgetThemer spotterStyleFor: self.
	self breadcrumbBrick: self newBreadcrumbBrick.
	self paneBrick: self newPaneBrick.! !

!GTSpotterMorph methodsFor: 'initialize' stamp: 'AliakseiSyrel 1/26/2015 15:53'!
initializeListeners

	self activeHand addEventListener: self.
	
	Morph announcer weak on: MorphLostFocus send: #onLostFocus: to: self.
	
	self bindKeyCombination: Character escape toAction: [ self escapePressed ].
	self bindKeyCombination: $w command toAction: [ self escapePressed ].
	self bindKeyCombination: $p command toAction: [ self togglePreview ].
	
	self bindKeyCombination: Character arrowUp toAction: [ self selectPreviousCandidate ].
	self bindKeyCombination: Character arrowDown toAction: [ self selectNextCandidate ].
	self bindKeyCombination: Character arrowUp command toAction: [ self selectPreviousCandidate ].
	self bindKeyCombination: Character arrowDown command toAction: [ self selectNextCandidate ].
	self bindKeyCombination: Character arrowUp shift toAction: [ self selectPreviousCandidate ].
	self bindKeyCombination: Character arrowDown shift toAction: [ self selectNextCandidate ].
	
	self bindKeyCombination: Character arrowUp command shift toAction: [ self selectPreviousCategory ].
	self bindKeyCombination: Character arrowDown command shift toAction: [ self selectNextCategory ].
	
	self bindKeyCombination: Character arrowRight command toAction: [ self diveIn ].
	self bindKeyCombination: Character arrowLeft command toAction: [ self diveOut ].

	self bindKeyCombination: Character arrowRight command shift toAction: [ self diveInCategory ].
	self bindKeyCombination: Character arrowLeft command shift toAction: [ self diveOut ].
	
	self 
		bindKeyCombination: Character cr asKeyCombination 
		toAction: [ self act ].
		
	self 
		bindKeyCombination: $p command shift 
		toAction: [ self exportAsPNGSilently ]! !

!GTSpotterMorph methodsFor: 'instance creation' stamp: 'TudorGirba 11/26/2014 14:34'!
newBreadcrumbBrick

	^ GTSpotterStepsBreadcrumb new! !

!GTSpotterMorph methodsFor: 'instance creation' stamp: 'AliakseiSyrel 1/20/2015 01:05'!
newPaneBrick

	^ GTSpotterPaneBrick new! !

!GTSpotterMorph methodsFor: 'events-processing' stamp: 'AliakseiSyrel 1/25/2015 15:32'!
onBreadcrumbVisibilityChanged

	self doLayout.
	self changed.! !

!GTSpotterMorph methodsFor: 'events-processing' stamp: 'AliakseiSyrel 1/27/2015 09:32'!
onHidePreview
	|delta|
	self paneBrick isPreviewShown ifFalse: [ ^ self ].
	delta := ((self width - ((self width / 100) * (100 - self theme spotterWidgetThemer previewWidthPercent)))@0) negated / 2.
	self bounds: (self bounds expandBy: delta).
	self paneBrick hidePreview.
	self doLayout! !

!GTSpotterMorph methodsFor: 'events-processing' stamp: 'AliakseiSyrel 10/23/2014 20:24'!
onLostFocus: event

	focusedMorph ifNil: [ focusedMorph := event morph ]! !

!GTSpotterMorph methodsFor: 'events-processing' stamp: 'AliakseiSyrel 1/27/2015 09:31'!
onShowPreview

	|delta|
	self paneBrick isPreviewShown ifTrue: [ ^ self ].
	delta := (((self width * 100) / (100 - self theme spotterWidgetThemer previewWidthPercent) - self width)@0) / 2.
	self bounds: (self bounds expandBy: delta).
	self paneBrick showPreview.
	self doLayout! !

!GTSpotterMorph methodsFor: 'opening' stamp: 'AliakseiSyrel 1/19/2015 20:48'!
openInWindowLabeled: aString inWorld: aWorld
	self autoHide: false.
	^ super openInWindowLabeled: aString inWorld: aWorld! !

!GTSpotterMorph methodsFor: 'initialize' stamp: 'StephanEggermont 12/8/2014 15:11'!
outOfWorld: aWorld
	super outOfWorld: aWorld.
	self unsubscribeListeners.
	
	self spotterModel ifNotNil: [:m | m terminateProcessors].
	
	"restoring previous focus"
	focusedMorph ifNotNil: [ focusedMorph takeKeyboardFocus ]! !

!GTSpotterMorph methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/20/2015 00:59'!
paneBrick

	^ paneBrick! !

!GTSpotterMorph methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/20/2015 01:00'!
paneBrick: aBrick
	
	paneBrick ifNotNil: [self removeBrick: paneBrick].
	paneBrick := aBrick.
		
	self theme spotterWidgetThemer spotterPaneStyleFor: paneBrick.

	self addBrickBack: paneBrick! !

!GTSpotterMorph methodsFor: 'actions' stamp: 'AliaskeiSyrel 11/13/2014 20:42'!
selectNextCandidate

	self spotterModel isEmpty
		ifFalse: [ self spotterModel currentStep selectNext ]
	! !

!GTSpotterMorph methodsFor: 'actions' stamp: 'AliakseiSyrel 11/19/2014 22:00'!
selectNextCategory

	self spotterModel isEmpty
		ifFalse: [ self spotterModel currentStep selectNextCategory ]
	! !

!GTSpotterMorph methodsFor: 'actions' stamp: 'AliaskeiSyrel 11/13/2014 20:42'!
selectPreviousCandidate

	self spotterModel isEmpty
		ifFalse: [ self spotterModel currentStep selectPrevious ]
	! !

!GTSpotterMorph methodsFor: 'actions' stamp: 'AliakseiSyrel 11/19/2014 22:00'!
selectPreviousCategory

	self spotterModel isEmpty
		ifFalse: [ self spotterModel currentStep selectPreviousCategory ]
	! !

!GTSpotterMorph methodsFor: 'actions' stamp: 'AliakseiSyrel 12/11/2014 12:06'!
shiftPressed

	self spotterModel isEmpty
		ifFalse: [ self spotterModel currentStep shiftPressed ]! !

!GTSpotterMorph methodsFor: 'actions' stamp: 'AliakseiSyrel 1/26/2015 15:54'!
showPreview
	
	self spotterModel showPreview! !

!GTSpotterMorph methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/24/2014 10:20'!
spotterModel

	^ spotterModel! !

!GTSpotterMorph methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/27/2015 11:01'!
spotterModel: aSpotter

	spotterModel := aSpotter.
	
	spotterModel announcer weak subscribe: GTSpotterExitAnnouncement send: #escapePressed to: self.
	spotterModel announcer weak subscribe: GTSpotterShowPreview send: #onShowPreview to: self.
	spotterModel announcer weak subscribe: GTSpotterHidePreview send: #onHidePreview to: self.
	
	self breadcrumbBrick spotterModel: spotterModel.
	self paneBrick spotterModel: spotterModel.
	
	"expanding drop down pane"
	self spotterModel setText: '' from: nil.
	self spotterModel currentStep process: nil.
	
	! !

!GTSpotterMorph methodsFor: 'actions' stamp: 'AliakseiSyrel 1/26/2015 15:54'!
togglePreview

	self spotterModel togglePreview! !

!GTSpotterMorph methodsFor: 'initialize' stamp: 'AliakseiSyrel 12/11/2014 11:52'!
unsubscribeListeners

	self activeHand removeEventListener: self.
	Morph announcer unsubscribe: self.! !

!Pharo3DarkTheme methodsFor: '*GT-Spotter' stamp: 'AliakseiSyrel 1/23/2015 12:57'!
spotterWidgetThemer
	^ GTSpotterWidgetDarkThemer new! !

RubTextScrollPane subclass: #GTSpotterSearchFieldScrollPane
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-UI'!

!GTSpotterSearchFieldScrollPane methodsFor: 'drawing' stamp: 'AliakseiSyrel 10/23/2014 16:57'!
drawKeyboardFocusOn: aCanvas
	"empty to remove focus border"! !

!GTSpotterSearchFieldScrollPane methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 10/24/2014 12:42'!
hScrollbarInterval
	"Answer the computed size of the thumb of the horizontal scrollbar."
	self scrollTarget width = 0 ifTrue: [ ^ 0 ].
	^self scrollBounds width asFloat / self scrollTarget width min: 1.0.! !

GLMBrickThemer subclass: #GTSpotterBrickThemer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Theme'!

!GTSpotterBrickThemer methodsFor: 'brick-scrollbar' stamp: 'AliakseiSyrel 1/26/2015 15:01'!
scrollbarColor

	^ Color lightGray alpha: 0.2! !

GLMInteractableBrick subclass: #GTSpotterCategoryTitleBrick
	instanceVariableNames: 'nameBrick amountBrick stepModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-UI'!

!GTSpotterCategoryTitleBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/19/2014 23:26'!
amountBrick

	^ amountBrick! !

!GTSpotterCategoryTitleBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/19/2014 23:27'!
amountBrick: aBrick

	amountBrick ifNotNil: [self removeBrick: amountBrick].
	amountBrick := aBrick.
	
	self theme spotterWidgetThemer categoryAmountStyleFor: amountBrick.
	
	self addBrickBack: amountBrick! !

!GTSpotterCategoryTitleBrick methodsFor: 'layouting' stamp: 'AliakseiSyrel 12/2/2014 00:41'!
doLayout
	
	super doLayout.
	
	self amountBrick isDotsAdded ifTrue: [
		self amountBrick layoutProperties horizontalPercent: 0.
		self layoutProperties paddingLeft: (((self width - self nameBrick width) / 2) ceiling max: 0).
		super doLayout ].! !

!GTSpotterCategoryTitleBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/18/2014 23:33'!
nameBrick

	^ nameBrick! !

!GTSpotterCategoryTitleBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/18/2014 23:48'!
nameBrick: aBrick

	nameBrick ifNotNil: [self removeBrick: nameBrick].
	nameBrick := aBrick.
	
	self theme spotterWidgetThemer categoryTitleNameStyleFor: nameBrick.
	
	self addBrickBack: nameBrick! !

!GTSpotterCategoryTitleBrick methodsFor: 'instance creation' stamp: 'AliakseiSyrel 11/19/2014 23:28'!
newAmountBrick

	^ GLMLabelBrick new! !

!GTSpotterCategoryTitleBrick methodsFor: 'instance creation' stamp: 'AliakseiSyrel 11/18/2014 23:33'!
newNameBrick

	^ GLMLabelBrick new! !

!GTSpotterCategoryTitleBrick methodsFor: 'instance creation' stamp: 'TudorGirba 11/26/2014 14:20'!
on: aStepModel category: aProcessor

	stepModel := aStepModel.
	
	self nameBrick: self newNameBrick.
	self nameBrick text: aProcessor title.
			
	self amountBrick: self newAmountBrick.
	self amountBrick text: '0/0'.


	^ self! !

!GTSpotterCategoryTitleBrick methodsFor: 'layouting' stamp: 'AliakseiSyrel 12/2/2014 00:47'!
onLayoutEvent: aLayoutEvent
	super onLayoutEvent: aLayoutEvent.
	
	(aLayoutEvent isKindOf: GLMBrickLayoutStacked) ifTrue: [ "self enable" ]! !

!GTSpotterCategoryTitleBrick methodsFor: 'layouting' stamp: 'AliakseiSyrel 12/2/2014 00:42'!
onPrepareLayout
	super onPrepareLayout.
	
	self amountBrick layoutProperties horizontalPercent: 100.
	self layoutProperties paddingLeft: (self theme spotterWidgetThemer categoryNameMarginLeft).
	self disable.! !

!GTSpotterCategoryTitleBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/23/2015 12:54'!
setAmountVisible: visible all: all

	self amountBrick text: (visible asString, '/', all asString).
	self amountBrick changed! !

GLMInteractableBrick subclass: #GTSpotterItemBrick
	instanceVariableNames: 'iconBrick labelBrick stepModel candidateLink actionbarBrick'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-UI'!

!GTSpotterItemBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/27/2014 11:31'!
actionbarBrick
	^ actionbarBrick! !

!GTSpotterItemBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/27/2014 12:36'!
actionbarBrick: aBrick

	actionbarBrick ifNotNil: [self removeBrick: actionbarBrick].
	actionbarBrick := aBrick.
	
	self theme spotterWidgetThemer itemActionbarStyleFor: aBrick.
	
	self addBrickBack: actionbarBrick! !

!GTSpotterItemBrick methodsFor: 'adding' stamp: 'AliakseiSyrel 12/27/2014 15:38'!
addActActionButton

	self actionbarBrick addActionButton: (self newActionButtonBrick
			icon: self theme spotterWidgetThemer iconAct;
			addUpAction: [ self beSelected. self stepModel act ];
			yourself)
		! !

!GTSpotterItemBrick methodsFor: 'adding' stamp: 'AliakseiSyrel 12/27/2014 15:38'!
addDiveInActionButton
		
	(self stepModel canDiveIn: self candidate) ifTrue: [
		self actionbarBrick addActionButton: (self newActionButtonBrick
			icon: self theme spotterWidgetThemer iconDiveIn;
			addUpAction: [ self beSelected. self stepModel diveIn ];
			yourself)]! !

!GTSpotterItemBrick methodsFor: 'actions' stamp: 'AliakseiSyrel 11/27/2014 11:49'!
beSelected
	self stepModel selected: self candidateLink
	! !

!GTSpotterItemBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/19/2014 00:13'!
candidate

	^ candidateLink value! !

!GTSpotterItemBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/19/2014 00:13'!
candidateLink

	^ candidateLink! !

!GTSpotterItemBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/19/2014 00:13'!
candidateLink: aDoubleLink 

	candidateLink := aDoubleLink! !

!GTSpotterItemBrick methodsFor: 'event handling' stamp: 'AliakseiSyrel 12/11/2014 12:37'!
check

	self showActionbar.
	super check.
	self notifySelected! !

!GTSpotterItemBrick methodsFor: 'event handling' stamp: 'AliakseiSyrel 11/27/2014 12:57'!
checkOrUncheck

	self stepModel selected = self candidateLink
		ifTrue: [ self isChecked ifFalse: [ self check ] ]
		ifFalse: [ self isChecked ifTrue: [ self uncheck ] ]! !

!GTSpotterItemBrick methodsFor: 'event handling' stamp: 'AliakseiSyrel 11/21/2014 14:46'!
doubleClick: evt

	self stepModel act! !

!GTSpotterItemBrick methodsFor: 'event handling' stamp: 'AliakseiSyrel 10/23/2014 20:02'!
handlesMouseDown: evt
	^ true! !

!GTSpotterItemBrick methodsFor: 'actions' stamp: 'AliakseiSyrel 11/27/2014 13:51'!
hideActionbar
		
	self theme spotterWidgetThemer itemActionbarInvisibleStyleFor: self actionbarBrick.
	self doLayout.! !

!GTSpotterItemBrick methodsFor: 'actions' stamp: 'AliakseiSyrel 12/4/2014 10:39'!
highlightQuery

	self labelBrick label highlight: self stepModel query! !

!GTSpotterItemBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/24/2014 09:57'!
icon: aForm

	self iconBrick normalImage: aForm.! !

!GTSpotterItemBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/18/2014 14:26'!
iconBrick
	^ iconBrick! !

!GTSpotterItemBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/24/2014 10:23'!
iconBrick: aBrick

	iconBrick ifNotNil: [self removeBrick: iconBrick].
	iconBrick := aBrick.
	
	self theme spotterWidgetThemer itemIconStyleFor: iconBrick.
	
	self addBrickBack: iconBrick! !

!GTSpotterItemBrick methodsFor: 'initialization' stamp: 'AliakseiSyrel 11/27/2014 12:45'!
initialize
	super initialize.
	self enable.
	
	self theme spotterWidgetThemer itemNormalStyleFor: self.
	
	self iconBrick: self newIconBrick.
	self labelBrick: self newLabelBrick.
	self actionbarBrick: self newActionbarBrick.! !

!GTSpotterItemBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/18/2014 14:26'!
labelBrick
	^ labelBrick! !

!GTSpotterItemBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/23/2014 19:29'!
labelBrick: aBrick

	labelBrick ifNotNil: [self removeBrick: labelBrick].
	labelBrick := aBrick.
	
	self theme spotterWidgetThemer itemLabelStyleFor: labelBrick.
	
	self addBrickBack: labelBrick! !

!GTSpotterItemBrick methodsFor: 'event handling' stamp: 'AndreiChis 1/23/2015 17:33'!
mouseDown: evt
	|selectors|
	
	self isEnabled ifFalse: [ ^ self ].
	
	selectors := Array
				with: #singleClick:
				with: #doubleClick:
				with: nil
				with: nil.
				
	evt hand
		waitForClicksOrDrag: self
		event: evt
		selectors: selectors
		threshold: 10
	! !

!GTSpotterItemBrick methodsFor: 'instance creation' stamp: 'AliakseiSyrel 11/27/2014 11:49'!
newActionButtonBrick

	^ GLMActionButtonBrick new! !

!GTSpotterItemBrick methodsFor: 'instance creation' stamp: 'AliakseiSyrel 11/27/2014 11:32'!
newActionbarBrick

	^ GTSpotterItemActionbarBrick new! !

!GTSpotterItemBrick methodsFor: 'instance creation' stamp: 'AliakseiSyrel 10/24/2014 10:27'!
newIconBrick

	^ GLMInteractableBrick new normalImage: ((Form extent: 16@16 depth: 32) fillAlpha: 0)! !

!GTSpotterItemBrick methodsFor: 'instance creation' stamp: 'TudorGirba 1/27/2015 23:42'!
newLabelBrick
	self flag: 'find a better number, or at least a better place for the number :)'.

	^ GLMLabelBrick new 
		text: 'Search result with very very long name';
		paddingRight: 16! !

!GTSpotterItemBrick methodsFor: 'notifying' stamp: 'AliakseiSyrel 1/25/2015 19:17'!
notifySelected

	self stepModel spotter announce: (GTSpotterCandidateSelected new candidateBrick: self)! !

!GTSpotterItemBrick methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 1/27/2015 11:10'!
onRemoved
	super onRemoved.
	"I must not receive any announcements as soon as i'm removed from dom"
	self stepModel ifNotNil: [ self stepModel announcer unsubscribe: self ]! !

!GTSpotterItemBrick methodsFor: 'event handling' stamp: 'AliakseiSyrel 11/27/2014 12:55'!
onSelectedChanged: ann

	self checkOrUncheck! !

!GTSpotterItemBrick methodsFor: 'event handling' stamp: 'AliakseiSyrel 1/25/2015 20:04'!
onStepPopped

	(self stepModel spotter steps last = self stepModel) & self isChecked ifTrue: [
		self notifySelected ]! !

!GTSpotterItemBrick methodsFor: 'actions' stamp: 'AliakseiSyrel 11/27/2014 12:40'!
showActionbar

	self theme spotterWidgetThemer itemActionbarVisibleStyleFor: self actionbarBrick.
	self doLayout.! !

!GTSpotterItemBrick methodsFor: 'event handling' stamp: 'AliakseiSyrel 11/27/2014 11:49'!
singleClick: evt

	self beSelected! !

!GTSpotterItemBrick methodsFor: 'accessing' stamp: 'AliaskeiSyrel 11/13/2014 20:28'!
stepModel

	^ stepModel! !

!GTSpotterItemBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/27/2015 10:53'!
stepModel: aModel

	stepModel := aModel.
	
	stepModel announcer weak subscribe: GTSpotterSelectedCandidateChanged send: #onSelectedChanged: to: self.
	stepModel spotter announcer weak subscribe: GTSpotterStepPopped send: #onStepPopped to: self.
	
	self
		addActActionButton;
		addDiveInActionButton;
		highlightQuery;
		checkOrUncheck.! !

!GTSpotterItemBrick methodsFor: 'accessing' stamp: 'AliaskeiSyrel 10/25/2014 18:34'!
text: aString

	self labelBrick text: aString.! !

!GTSpotterItemBrick methodsFor: 'event handling' stamp: 'AliakseiSyrel 12/1/2014 23:20'!
uncheck
	
	super uncheck.
	
	self hideActionbar! !

TestCase subclass: #GTSpotterA1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Tests'!

TestCase subclass: #GTSpotterA2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Tests'!

TestCase subclass: #GTSpotterA3
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Tests'!

TestCase subclass: #GTSpotterCandidatesListTest
	instanceVariableNames: 'candidates'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Tests'!

!GTSpotterCandidatesListTest methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 11/24/2014 20:42'!
addCategories: aCollection

	aCollection do: [ :each | candidates addProcessor: each ]! !

!GTSpotterCandidatesListTest methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 11/24/2014 20:52'!
hasCategories: aCollection
	|counter|
	candidates processors asArray size = aCollection size ifFalse: [ ^ false ].
	counter := 1.
	candidates processors asArray
		do: [ :each | (each = (aCollection at: counter)) ifFalse: [ ^ false ] . counter := counter + 1].
	^ true! !

!GTSpotterCandidatesListTest methodsFor: 'running' stamp: 'TudorGirba 11/26/2014 14:34'!
setUp

	candidates := GTSpotterCandidatesList new.! !

!GTSpotterCandidatesListTest methodsFor: 'as yet unclassified' stamp: 'TudorGirba 12/7/2014 13:06'!
testAddCategories
	|categories|
	categories := { GTSpotterA1 . GTSpotterA2 . GTSpotterA3 }.
	
	self addCategories: categories.
	self assert: (self hasCategories: categories)! !

!GTSpotterCandidatesListTest methodsFor: 'as yet unclassified' stamp: 'TudorGirba 12/7/2014 13:06'!
testAddOneCandidateA1
	|link category|
	
	category := candidates addProcessor: GTSpotterA1.
	link := candidates addCandidate: 11 in: GTSpotterA1.
	
	self assert: (link nextLink = link).
	self assert: (link previousLink = link).
	self assert: (candidates head = link).
	self assert: (candidates tail = link).
	self assert: ((category headLink) = link).
	self assert: ((category tailLink) = link).
	
	! !

!GTSpotterCandidatesListTest methodsFor: 'as yet unclassified' stamp: 'TudorGirba 12/7/2014 13:06'!
testAddOneCandidateA1A2
	|link11 link21 category1 category2|
	
	category1 := candidates addProcessor: GTSpotterA1.
	category2 := candidates addProcessor: GTSpotterA2.
	link11 := candidates addCandidate: 11 in: GTSpotterA1.
	link21 := candidates addCandidate: 21 in: GTSpotterA2.
	
	self assert: (link11 nextLink = link21).
	self assert: (link11 previousLink = link21).
	
	self assert: (link21 nextLink = link11).
	self assert: (link21 previousLink = link11).
	
	self assert: (candidates head = link11).
	self assert: (candidates tail = link21).
	
	self assert: ((category1 headLink) = link11).
	self assert: ((category1 tailLink) = link11).
	
	self assert: ((category2 headLink) = link21).
	self assert: ((category2 tailLink) = link21).
	
	! !

!GTSpotterCandidatesListTest methodsFor: 'as yet unclassified' stamp: 'TudorGirba 12/7/2014 13:07'!
testAddOneCandidateA1A2A3
	|link11 link21 link31 category1 category2 category3|
	
	category1 := candidates addProcessor: GTSpotterA1.
	category2 := candidates addProcessor: GTSpotterA2.
	category3 := candidates addProcessor: GTSpotterA3.
	
	link11 := candidates addCandidate: 11 in: GTSpotterA1.
	link21 := candidates addCandidate: 21 in: GTSpotterA2.
	link31 := candidates addCandidate: 31 in: GTSpotterA3.
	
	self assert: (link11 nextLink = link21).
	self assert: (link11 previousLink = link31).
	
	self assert: (link21 nextLink = link31).
	self assert: (link21 previousLink = link11).
	
	self assert: (link31 nextLink = link11).
	self assert: (link31 previousLink = link21).
		
	self assert: (candidates head = link11).
	self assert: (candidates tail = link31).
	
	self assert: ((category1 headLink) = link11).
	self assert: ((category1 tailLink) = link11).
	
	self assert: ((category2 headLink) = link21).
	self assert: ((category2 tailLink) = link21).
	
	self assert: ((category3 headLink) = link31).
	self assert: ((category3 tailLink) = link31).! !

!GTSpotterCandidatesListTest methodsFor: 'as yet unclassified' stamp: 'TudorGirba 12/7/2014 13:07'!
testAddThreeCandidateA1
	|link1 link2 link3 category|
	
	category := candidates addProcessor: GTSpotterA1.
	link1 := candidates addCandidate: 11 in: GTSpotterA1.
	link2 := candidates addCandidate: 12 in: GTSpotterA1.
	link3 := candidates addCandidate: 13 in: GTSpotterA1.
	
	self assert: (link1 nextLink = link2).
	self assert: (link1 previousLink = link3).
	
	self assert: (link2 nextLink = link3).
	self assert: (link2 previousLink = link1).
	
	self assert: (link3 nextLink = link1).
	self assert: (link3 previousLink = link2).
	
	self assert: (candidates head = link1).
	self assert: (candidates tail = link3).
	self assert: ((category headLink) = link1).
	self assert: ((category tailLink) = link3).
	
	! !

!GTSpotterCandidatesListTest methodsFor: 'as yet unclassified' stamp: 'TudorGirba 12/7/2014 13:07'!
testAddThreeCandidateA1A2
	|link11 link12 link13 link21 link22 link23 category1 category2|
	
	category1 := candidates addProcessor: GTSpotterA1.
	category2 := candidates addProcessor: GTSpotterA2.
	
	link11 := candidates addCandidate: 11 in: GTSpotterA1.
	link12 := candidates addCandidate: 12 in: GTSpotterA1.
	link13 := candidates addCandidate: 13 in: GTSpotterA1.
	link21 := candidates addCandidate: 21 in: GTSpotterA2.
	link22 := candidates addCandidate: 22 in: GTSpotterA2.
	link23 := candidates addCandidate: 23 in: GTSpotterA2.
	
	self assert: (link11 nextLink = link12).
	self assert: (link11 previousLink = link23).
	
	self assert: (link12 nextLink = link13).
	self assert: (link12 previousLink = link11).
	
	self assert: (link13 nextLink = link21).
	self assert: (link13 previousLink = link12).
	
	self assert: (link21 nextLink = link22).
	self assert: (link21 previousLink = link13).
	
	self assert: (link22 nextLink = link23).
	self assert: (link22 previousLink = link21).
	
	self assert: (link23 nextLink = link11).
	self assert: (link23 previousLink = link22).
	
	self assert: (candidates head = link11).
	self assert: (candidates tail = link23).
	
	self assert: ((category1 headLink) = link11).
	self assert: ((category1 tailLink) = link13).
	
	self assert: ((category2 headLink) = link21).
	self assert: ((category2 tailLink) = link23).! !

!GTSpotterCandidatesListTest methodsFor: 'as yet unclassified' stamp: 'TudorGirba 12/7/2014 13:07'!
testAddThreeCandidateA1A2A3
	|link11 link12 link13 link21 link22 link23 link31 link32 link33 category1 category2 category3|
	
	category1 := candidates addProcessor: GTSpotterA1.
	category2 := candidates addProcessor: GTSpotterA2.
	category3 := candidates addProcessor: GTSpotterA3.
	
	link11 := candidates addCandidate: 11 in: GTSpotterA1.
	link12 := candidates addCandidate: 12 in: GTSpotterA1.
	link13 := candidates addCandidate: 13 in: GTSpotterA1.
	link21 := candidates addCandidate: 21 in: GTSpotterA2.
	link22 := candidates addCandidate: 22 in: GTSpotterA2.
	link23 := candidates addCandidate: 23 in: GTSpotterA2.
	link31 := candidates addCandidate: 31 in: GTSpotterA3.
	link32 := candidates addCandidate: 32 in: GTSpotterA3.
	link33 := candidates addCandidate: 33 in: GTSpotterA3.
	
	self assert: (link11 nextLink = link12).
	self assert: (link11 previousLink = link33).
	
	self assert: (link12 nextLink = link13).
	self assert: (link12 previousLink = link11).
	
	self assert: (link13 nextLink = link21).
	self assert: (link13 previousLink = link12).
	
	self assert: (link21 nextLink = link22).
	self assert: (link21 previousLink = link13).
	
	self assert: (link22 nextLink = link23).
	self assert: (link22 previousLink = link21).
	
	self assert: (link23 nextLink = link31).
	self assert: (link23 previousLink = link22).
	
	self assert: (link31 nextLink = link32).
	self assert: (link31 previousLink = link23).
	
	self assert: (link32 nextLink = link33).
	self assert: (link32 previousLink = link31).
	
	self assert: (link33 nextLink = link11).
	self assert: (link33 previousLink = link32).
		
	self assert: (candidates head = link11).
	self assert: (candidates tail = link33).
	
	self assert: ((category1 headLink) = link11).
	self assert: ((category1 tailLink) = link13).
	
	self assert: ((category2 headLink) = link21).
	self assert: ((category2 tailLink) = link23).
	
	self assert: ((category3 headLink) = link31).
	self assert: ((category3 tailLink) = link33).! !

!GTSpotterCandidatesListTest methodsFor: 'as yet unclassified' stamp: 'TudorGirba 12/7/2014 13:08'!
testAddThreeCandidateA1A2A3Shuffled
	|link11 link12 link13 link21 link22 link23 link31 link32 link33 category1 category2 category3|
	
	category1 := candidates addProcessor: GTSpotterA1.
	category2 := candidates addProcessor: GTSpotterA2.
	category3 := candidates addProcessor: GTSpotterA3.
	
	link21 := candidates addCandidate: 21 in: GTSpotterA2.
	link22 := candidates addCandidate: 22 in: GTSpotterA2.
	link11 := candidates addCandidate: 11 in: GTSpotterA1.
	link31 := candidates addCandidate: 31 in: GTSpotterA3.
	link12 := candidates addCandidate: 12 in: GTSpotterA1.
	link32 := candidates addCandidate: 32 in: GTSpotterA3.
	link23 := candidates addCandidate: 23 in: GTSpotterA2.
	link33 := candidates addCandidate: 33 in: GTSpotterA3.
	link13 := candidates addCandidate: 13 in: GTSpotterA1.
	
	self assert: (link11 nextLink = link12).
	self assert: (link11 previousLink = link33).
	
	self assert: (link12 nextLink = link13).
	self assert: (link12 previousLink = link11).
	
	self assert: (link13 nextLink = link21).
	self assert: (link13 previousLink = link12).
	
	self assert: (link21 nextLink = link22).
	self assert: (link21 previousLink = link13).
	
	self assert: (link22 nextLink = link23).
	self assert: (link22 previousLink = link21).
	
	self assert: (link23 nextLink = link31).
	self assert: (link23 previousLink = link22).
	
	self assert: (link31 nextLink = link32).
	self assert: (link31 previousLink = link23).
	
	self assert: (link32 nextLink = link33).
	self assert: (link32 previousLink = link31).
	
	self assert: (link33 nextLink = link11).
	self assert: (link33 previousLink = link32).
		
	self assert: (candidates head = link11).
	self assert: (candidates tail = link33).
	
	self assert: ((category1 headLink) = link11).
	self assert: ((category1 tailLink) = link13).
	
	self assert: ((category2 headLink) = link21).
	self assert: ((category2 tailLink) = link23).
	
	self assert: ((category3 headLink) = link31).
	self assert: ((category3 tailLink) = link33).! !

!GTSpotterCandidatesListTest methodsFor: 'as yet unclassified' stamp: 'TudorGirba 12/7/2014 13:08'!
testAddTwoCandidateA1
	|link1 link2 category|
	
	category := candidates addProcessor: GTSpotterA1.
	link1 := candidates addCandidate: 11 in: GTSpotterA1.
	link2 := candidates addCandidate: 12 in: GTSpotterA1.
	
	self assert: (link1 nextLink = link2).
	self assert: (link1 previousLink = link2).
	
	self assert: (link2 nextLink = link1).
	self assert: (link2 previousLink = link1).
	
	self assert: (candidates head = link1).
	self assert: (candidates tail = link2).
	self assert: ((category headLink) = link1).
	self assert: ((category tailLink) = link2).
	
	! !

!GTSpotterCandidatesListTest methodsFor: 'as yet unclassified' stamp: 'TudorGirba 12/7/2014 13:08'!
testAddTwoCandidateA1A2
	|link11 link12 link21 link22 category1 category2|
	
	category1 := candidates addProcessor: GTSpotterA1.
	category2 := candidates addProcessor: GTSpotterA2.
	
	link11 := candidates addCandidate: 11 in: GTSpotterA1.
	link12 := candidates addCandidate: 12 in: GTSpotterA1.
	link21 := candidates addCandidate: 21 in: GTSpotterA2.
	link22 := candidates addCandidate: 22 in: GTSpotterA2.
	
	self assert: (link11 nextLink = link12).
	self assert: (link11 previousLink = link22).
	
	self assert: (link12 nextLink = link21).
	self assert: (link12 previousLink = link11).
	
	self assert: (link21 nextLink = link22).
	self assert: (link21 previousLink = link12).
	
	self assert: (link22 nextLink = link11).
	self assert: (link22 previousLink = link21).
	
	self assert: (candidates head = link11).
	self assert: (candidates tail = link22).
	
	self assert: ((category1 headLink) = link11).
	self assert: ((category1 tailLink) = link12).
	
	self assert: ((category2 headLink) = link21).
	self assert: ((category2 tailLink) = link22).
	
	! !

!GTSpotterCandidatesListTest methodsFor: 'as yet unclassified' stamp: 'TudorGirba 12/7/2014 13:09'!
testAddTwoCandidateA1A2A3
	|link11 link12 link21 link22 link31 link32 category1 category2 category3|
	
	category1 := candidates addProcessor: GTSpotterA1.
	category2 := candidates addProcessor: GTSpotterA2.
	category3 := candidates addProcessor: GTSpotterA3.
	
	link11 := candidates addCandidate: 11 in: GTSpotterA1.
	link12 := candidates addCandidate: 12 in: GTSpotterA1.
	link21 := candidates addCandidate: 21 in: GTSpotterA2.
	link22 := candidates addCandidate: 22 in: GTSpotterA2.
	link31 := candidates addCandidate: 31 in: GTSpotterA3.
	link32 := candidates addCandidate: 32 in: GTSpotterA3.
	
	self assert: (link11 nextLink = link12).
	self assert: (link11 previousLink = link32).
	
	self assert: (link12 nextLink = link21).
	self assert: (link12 previousLink = link11).
	
	self assert: (link21 nextLink = link22).
	self assert: (link21 previousLink = link12).
	
	self assert: (link22 nextLink = link31).
	self assert: (link22 previousLink = link21).
	
	self assert: (link31 nextLink = link32).
	self assert: (link31 previousLink = link22).
	
	self assert: (link32 nextLink = link11).
	self assert: (link32 previousLink = link31).
		
	self assert: (candidates head = link11).
	self assert: (candidates tail = link32).
	
	self assert: ((category1 headLink) = link11).
	self assert: ((category1 tailLink) = link12).
	
	self assert: ((category2 headLink) = link21).
	self assert: ((category2 tailLink) = link22).
	
	self assert: ((category3 headLink) = link31).
	self assert: ((category3 tailLink) = link32).! !

!GTSpotterCandidatesListTest methodsFor: 'as yet unclassified' stamp: 'TudorGirba 12/7/2014 13:09'!
testCategoryLinkByCandidateLinkThreeA1A2A3
	|link11 link12 link13 link21 link22 link23 link31 link32 link33 category1 category2 category3|
	
	category1 := candidates addProcessor: GTSpotterA1.
	category2 := candidates addProcessor: GTSpotterA2.
	category3 := candidates addProcessor: GTSpotterA3.
	
	link11 := candidates addCandidate: 11 in: GTSpotterA1.
	link12 := candidates addCandidate: 12 in: GTSpotterA1.
	link13 := candidates addCandidate: 13 in: GTSpotterA1.
	link21 := candidates addCandidate: 21 in: GTSpotterA2.
	link22 := candidates addCandidate: 22 in: GTSpotterA2.
	link23 := candidates addCandidate: 23 in: GTSpotterA2.
	link31 := candidates addCandidate: 31 in: GTSpotterA3.
	link32 := candidates addCandidate: 32 in: GTSpotterA3.
	link33 := candidates addCandidate: 33 in: GTSpotterA3.
	
	self assert: (category1 = (candidates getProcessorLinkByCandidateLink: link11)).
	self assert: (category1 = (candidates getProcessorLinkByCandidateLink: link12)).
	self assert: (category1 = (candidates getProcessorLinkByCandidateLink: link13)).
	
	self assert: (category2 = (candidates getProcessorLinkByCandidateLink: link21)).
	self assert: (category2 = (candidates getProcessorLinkByCandidateLink: link22)).
	self assert: (category2 = (candidates getProcessorLinkByCandidateLink: link23)).
	
	self assert: (category3 = (candidates getProcessorLinkByCandidateLink: link31)).
	self assert: (category3 = (candidates getProcessorLinkByCandidateLink: link32)).
	self assert: (category3 = (candidates getProcessorLinkByCandidateLink: link33)).! !

!GTSpotterCandidatesListTest methodsFor: 'as yet unclassified' stamp: 'TudorGirba 12/7/2014 13:10'!
testNextA1A2Category

	|link11 link12 link13 link21 link22 link23 category1 category2|
	
	category1 := candidates addProcessor: GTSpotterA1.
	category2 := candidates addProcessor: GTSpotterA2.
	
	link11 := candidates addCandidate: 11 in: GTSpotterA1.
	link12 := candidates addCandidate: 12 in: GTSpotterA1.
	link13 := candidates addCandidate: 13 in: GTSpotterA1.
	link21 := candidates addCandidate: 21 in: GTSpotterA2.
	link22 := candidates addCandidate: 22 in: GTSpotterA2.
	link23 := candidates addCandidate: 23 in: GTSpotterA2.
	
	self assert: (category1 = (candidates nextProcessorLinkOf: category2)).
	self assert: (category2 = (candidates nextProcessorLinkOf: category1)).
	
	! !

!GTSpotterCandidatesListTest methodsFor: 'as yet unclassified' stamp: 'TudorGirba 12/7/2014 13:10'!
testNextA1A2EmptyCategory

	|link11 link12 link13 category1 category2|
	
	category1 := candidates addProcessor: GTSpotterA1.
	category2 := candidates addProcessor: GTSpotterA2.
	
	link11 := candidates addCandidate: 11 in: GTSpotterA1.
	link12 := candidates addCandidate: 12 in: GTSpotterA1.
	link13 := candidates addCandidate: 13 in: GTSpotterA1.
	
	self assert: (category1 = (candidates nextProcessorLinkOf: category1)).
	self assert: (category1 = (candidates nextProcessorLinkOf: category2)).
	
	! !

!GTSpotterCandidatesListTest methodsFor: 'as yet unclassified' stamp: 'TudorGirba 12/7/2014 13:10'!
testNextA1Category

	|link11 link12 link13 category1 |
	
	category1 := candidates addProcessor: GTSpotterA1.
	
	link11 := candidates addCandidate: 11 in: GTSpotterA1.
	link12 := candidates addCandidate: 12 in: GTSpotterA1.
	link13 := candidates addCandidate: 13 in: GTSpotterA1.
	
	self assert: (category1 = (candidates nextProcessorLinkOf: category1)).
	
	! !

!GTSpotterCandidatesListTest methodsFor: 'as yet unclassified' stamp: 'TudorGirba 12/7/2014 13:10'!
testPreviousA1A2Category

	|link11 link12 link13 link21 link22 link23 category1 category2|
	
	category1 := candidates addProcessor: GTSpotterA1.
	category2 := candidates addProcessor: GTSpotterA2.
	
	link11 := candidates addCandidate: 11 in: GTSpotterA1.
	link12 := candidates addCandidate: 12 in: GTSpotterA1.
	link13 := candidates addCandidate: 13 in: GTSpotterA1.
	link21 := candidates addCandidate: 21 in: GTSpotterA2.
	link22 := candidates addCandidate: 22 in: GTSpotterA2.
	link23 := candidates addCandidate: 23 in: GTSpotterA2.
	
	self assert: (category1 = (candidates previousProcessorLinkOf: category2)).
	self assert: (category2 = (candidates previousProcessorLinkOf: category1)).
	
	! !

!GTSpotterCandidatesListTest methodsFor: 'as yet unclassified' stamp: 'TudorGirba 12/7/2014 13:11'!
testPreviousA1A2EmptyCategory

	|link11 link12 link13 category1 category2|
	
	category1 := candidates addProcessor: GTSpotterA1.
	category2 := candidates addProcessor: GTSpotterA2.
	
	link11 := candidates addCandidate: 11 in: GTSpotterA1.
	link12 := candidates addCandidate: 12 in: GTSpotterA1.
	link13 := candidates addCandidate: 13 in: GTSpotterA1.
	
	self assert: (category1 = (candidates previousProcessorLinkOf: category1)).
	self assert: (category1 = (candidates previousProcessorLinkOf: category2)).
	
	! !

!GTSpotterCandidatesListTest methodsFor: 'as yet unclassified' stamp: 'TudorGirba 12/7/2014 13:11'!
testPreviousA1Category

	|link11 link12 link13 category1 |
	
	category1 := candidates addProcessor: GTSpotterA1.
	
	link11 := candidates addCandidate: 11 in: GTSpotterA1.
	link12 := candidates addCandidate: 12 in: GTSpotterA1.
	link13 := candidates addCandidate: 13 in: GTSpotterA1.
	
	self assert: (category1 = (candidates previousProcessorLinkOf: category1)).
	
	! !

!GTSpotterCandidatesListTest methodsFor: 'as yet unclassified' stamp: 'TudorGirba 12/7/2014 13:11'!
testRemoveCandidatesA1A2A3FromA1A2A3
	|category1 category2 category3|
	
	category1 := candidates addProcessor: GTSpotterA1.
	category2 := candidates addProcessor: GTSpotterA2.
	category3 := candidates addProcessor: GTSpotterA3.
	
	candidates addCandidate: 11 in: GTSpotterA1.
	candidates addCandidate: 12 in: GTSpotterA1.
	candidates addCandidate: 13 in: GTSpotterA1.
	candidates addCandidate: 21 in: GTSpotterA2.
	candidates addCandidate: 22 in: GTSpotterA2.
	candidates addCandidate: 23 in: GTSpotterA2.
	candidates addCandidate: 31 in: GTSpotterA3.
	candidates addCandidate: 32 in: GTSpotterA3.
	candidates addCandidate: 33 in: GTSpotterA3.
	
	candidates removeAllCandidatesOf: GTSpotterA1.
	candidates removeAllCandidatesOf: GTSpotterA3.
	candidates removeAllCandidatesOf: GTSpotterA2.
			
	self assert: (candidates head = nil).
	self assert: (candidates tail = nil).
	
	self assert: ((category1 headLink) = nil).
	self assert: ((category1 tailLink) = nil).
	
	self assert: ((category2 headLink) = nil).
	self assert: ((category2 tailLink) = nil).
	
	self assert: ((category3 headLink) = nil).
	self assert: ((category3 tailLink) = nil).! !

!GTSpotterCandidatesListTest methodsFor: 'as yet unclassified' stamp: 'TudorGirba 12/7/2014 13:12'!
testRemoveCandidatesA1A3FromA1A2A3
	|link21 link22 link23 category1 category2 category3|
	
	category1 := candidates addProcessor: GTSpotterA1.
	category2 := candidates addProcessor: GTSpotterA2.
	category3 := candidates addProcessor: GTSpotterA3.
	
	candidates addCandidate: 11 in: GTSpotterA1.
	candidates addCandidate: 12 in: GTSpotterA1.
	candidates addCandidate: 13 in: GTSpotterA1.
	link21 := candidates addCandidate: 21 in: GTSpotterA2.
	link22 := candidates addCandidate: 22 in: GTSpotterA2.
	link23 := candidates addCandidate: 23 in: GTSpotterA2.
	candidates addCandidate: 31 in: GTSpotterA3.
	candidates addCandidate: 32 in: GTSpotterA3.
	candidates addCandidate: 33 in: GTSpotterA3.
	
	candidates removeAllCandidatesOf: GTSpotterA1.
	candidates removeAllCandidatesOf: GTSpotterA3.
	
	self assert: (link21 nextLink = link22).
	self assert: (link21 previousLink = link23).
	
	self assert: (link22 nextLink = link23).
	self assert: (link22 previousLink = link21).
	
	self assert: (link23 nextLink = link21).
	self assert: (link23 previousLink = link22).
		
	self assert: (candidates head = link21).
	self assert: (candidates tail = link23).
	
	self assert: ((category1 headLink) = nil).
	self assert: ((category1 tailLink) = nil).
	
	self assert: ((category2 headLink) = link21).
	self assert: ((category2 tailLink) = link23).
	
	self assert: ((category3 headLink) = nil).
	self assert: ((category3 tailLink) = nil).! !

!GTSpotterCandidatesListTest methodsFor: 'as yet unclassified' stamp: 'TudorGirba 12/7/2014 13:12'!
testRemoveCandidatesA1FromA1A2A3
	|link21 link22 link23 link31 link32 link33 category1 category2 category3|
	
	category1 := candidates addProcessor: GTSpotterA1.
	category2 := candidates addProcessor: GTSpotterA2.
	category3 := candidates addProcessor: GTSpotterA3.
	
	candidates addCandidate: 11 in: GTSpotterA1.
	candidates addCandidate: 12 in: GTSpotterA1.
	candidates addCandidate: 13 in: GTSpotterA1.
	link21 := candidates addCandidate: 21 in: GTSpotterA2.
	link22 := candidates addCandidate: 22 in: GTSpotterA2.
	link23 := candidates addCandidate: 23 in: GTSpotterA2.
	link31 := candidates addCandidate: 31 in: GTSpotterA3.
	link32 := candidates addCandidate: 32 in: GTSpotterA3.
	link33 := candidates addCandidate: 33 in: GTSpotterA3.
	
	candidates removeAllCandidatesOf: GTSpotterA1.
	
	self assert: (link21 nextLink = link22).
	self assert: (link21 previousLink = link33).
	
	self assert: (link22 nextLink = link23).
	self assert: (link22 previousLink = link21).
	
	self assert: (link23 nextLink = link31).
	self assert: (link23 previousLink = link22).
	
	self assert: (link31 nextLink = link32).
	self assert: (link31 previousLink = link23).
	
	self assert: (link32 nextLink = link33).
	self assert: (link32 previousLink = link31).
	
	self assert: (link33 nextLink = link21).
	self assert: (link33 previousLink = link32).
		
	self assert: (candidates head = link21).
	self assert: (candidates tail = link33).
	
	self assert: ((category1 headLink) = nil).
	self assert: ((category1 tailLink) = nil).
	
	self assert: ((category2 headLink) = link21).
	self assert: ((category2 tailLink) = link23).
	
	self assert: ((category3 headLink) = link31).
	self assert: ((category3 tailLink) = link33).! !

GLMPagerMorph subclass: #GTSpotterDropDownMorph
	instanceVariableNames: 'spotterModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-UI'!

!GTSpotterDropDownMorph methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 12/10/2014 13:44'!
buildPane: aStepModel
	|pane|
	
	pane := GTSpotterResultsBrick new stepModel: aStepModel.
	self theme spotterWidgetThemer resultsPaneStyleFor: pane.
	^ pane! !

!GTSpotterDropDownMorph methodsFor: 'initialization' stamp: 'AliakseiSyrel 11/15/2014 15:50'!
initialize
	super initialize.
	
	self showScrollBarWhenNeeded: false! !

!GTSpotterDropDownMorph methodsFor: 'event handling' stamp: 'AliakseiSyrel 12/10/2014 13:44'!
onStepAdded: ann
	"as soon as step added we need to push it"

	self pushPane: (self buildPane: ann stepModel)! !

!GTSpotterDropDownMorph methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/24/2014 13:29'!
spotterModel
	^ spotterModel! !

!GTSpotterDropDownMorph methodsFor: 'accessing' stamp: 'AliakseiSyrel 12/10/2014 13:45'!
spotterModel: aModel 
	spotterModel := aModel.
	
	spotterModel steps do: [ :each | self pushPane: (self buildPane: each) ].
	
	spotterModel announcer subscribe: GTSpotterStepAdded send: #onStepAdded: to: self.! !

Object subclass: #GTAsyncTask
	instanceVariableNames: 'process callback'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Async'!

!GTAsyncTask commentStamp: 'TudorGirba 11/26/2014 15:07' prior: 0!
This is a utility that: 
- executes a job asynchroniously
- it remembers the process so that it can terminate the job, if needed
- triggers a callback when it's done!

!GTAsyncTask methodsFor: 'async' stamp: 'AliakseiSyrel 11/30/2014 22:22'!
complete: anObject callback: aBlock
	
	process ifNil: [ ^ self terminate ].
	process isTerminated ifFalse: [ "for some cases when we try to return result of wrong process" ^ self ].
	
	callback = aBlock ifFalse: [ ^ self terminate ].
	
	callback ifNotNil: [ callback cull: anObject ].
	process := nil.! !

!GTAsyncTask methodsFor: 'async' stamp: 'AliakseiSyrel 1/27/2015 11:52'!
execute: aBlock withArguments: aCollection callback: callbackBlock
	"execution happens with UI process priority so that communication with UI can be done in real time"
	
	^ self execute: aBlock withArguments: aCollection callback: callbackBlock priority: Processor userSchedulingPriority! !

!GTAsyncTask methodsFor: 'async' stamp: 'AliakseiSyrel 1/28/2015 11:42'!
execute: aBlock withArguments: aCollection callback: callbackBlock delay: anIntegerMilliseconds
	"execution happens with UI process priority so that communication with UI can be done in real time"
	
	^ self execute: aBlock withArguments: aCollection callback: callbackBlock priority: Processor userSchedulingPriority delay: anIntegerMilliseconds! !

!GTAsyncTask methodsFor: 'async' stamp: 'AliakseiSyrel 1/28/2015 11:41'!
execute: aBlock withArguments: aCollection callback: callbackBlock priority: aPriority
		
	^ self execute: aBlock withArguments: aCollection callback: callbackBlock priority: aPriority delay: 0! !

!GTAsyncTask methodsFor: 'async' stamp: 'AliakseiSyrel 1/28/2015 11:40'!
execute: aBlock withArguments: aCollection callback: callbackBlock priority: aPriority delay: anIntegerMilliseconds
	
	self terminate.
	
	callback := callbackBlock.
	process := [ |result|
		anIntegerMilliseconds > 0 ifTrue: [ anIntegerMilliseconds milliseconds wait ].
		result := aBlock valueWithArguments: aCollection.
		"we use it to pass result from background thread and execute callback block in UI thread"
		UIManager default defer: [ self complete: result callback: callbackBlock ]
	]	newProcess.
	
	process priority: aPriority.
	process resume.
		
	^ self! !

!GTAsyncTask methodsFor: 'async' stamp: 'AliakseiSyrel 11/30/2014 22:15'!
terminate

	process ifNotNil: [ process terminate. process := nil ].
	callback := nil.! !

Object subclass: #GTSpotter
	instanceVariableNames: 'foundationOrigin steps announcer currentStep pagerModel text isPreviewVisible'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Model'!

GTSpotter class
	instanceVariableNames: 'history'!

!GTSpotter commentStamp: 'TudorGirba 11/26/2014 14:06' prior: 0!
This is the main model class.

It handles the steps of the search, and it handles the search text.!

GTSpotter class
	instanceVariableNames: 'history'!

!GTSpotter class methodsFor: 'example' stamp: 'AliakseiSyrel 1/19/2015 21:28'!
exampleInWindow
	
	^ GTSpotterMorph new
		extent: 400@500;
		doLayout;
		spotterModel: self new;
		openInWindow! !

!GTSpotter class methodsFor: 'example' stamp: 'AliakseiSyrel 1/19/2015 21:28'!
exampleMC
	"self exampleMC"
	
	^ GTSpotterMorph new
		extent: 400@500;
		doLayout;
		spotterModel: (self on: MCWorkingCopy allManagers);
		openCenteredInWorld! !

!GTSpotter class methodsFor: 'example' stamp: 'AliakseiSyrel 1/27/2015 09:54'!
exampleWithPreview
	<example>
	^ GTSpotterMorph new
		extent: (World width / 2.5 @ (World height / 1.5)) asIntegerPoint;
		spotterModel: self new;
		showPreview;
		openCenteredInWorld! !

!GTSpotter class methodsFor: 'example' stamp: 'AliakseiSyrel 1/19/2015 21:28'!
exampleWorldMenu
	
	^ GTSpotterMorph new
		extent: 400@500;
		doLayout;
		spotterModel: (self on: World worldMenu);
		openCenteredInWorld! !

!GTSpotter class methodsFor: 'inspecting' stamp: 'TudorGirba 11/27/2014 06:57'!
gtInspectorExtensionsIn: composite
	<gtInspectorPresentationOrder: 40>
	composite list
		title: 'Extensions';
		display: [ self spotterExtendingMethods ];
		showOnly: 50;
		format: [ :each | each gtDisplayString ];
		filterOn: [ :text :each | each gtDisplayString includesSubstring: text caseSensitive: false ]! !

!GTSpotter class methodsFor: 'accessing' stamp: 'TudorGirba 12/1/2014 23:59'!
history
	^ history ifNil: [ history := WeakOrderedCollection new ]! !

!GTSpotter class methodsFor: 'instance creation' stamp: 'AliaskeiSyrel 11/8/2014 16:37'!
on: anObject
	
	^ self new foundationOrigin: anObject! !

!GTSpotter class methodsFor: 'accessing' stamp: 'TudorGirba 12/5/2014 06:28'!
resetHistory
	"self resetHistory"
	^ history := nil! !

!GTSpotter class methodsFor: 'inspecting' stamp: 'TudorGirba 11/27/2014 06:57'!
spotterExtendingMethods
	^(Object withAllSubclasses
		flatCollect: [ :each | 
			(Pragma allNamed: #spotterOrder: in: each) 
				collect: [ :p | p method asRingDefinition ] ])
		sorted! !

!GTSpotter methodsFor: 'actions api' stamp: 'AliakseiSyrel 12/11/2014 00:00'!
addStep: aStepModel
	self steps add: aStepModel.
	self notifyStepAdded: aStepModel! !

!GTSpotter methodsFor: 'notifying' stamp: 'AliakseiSyrel 1/25/2015 19:15'!
announce: anAnnouncement
	
	self announcer announce: anAnnouncement! !

!GTSpotter methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/24/2014 11:27'!
announcer
	^ announcer ifNil: [ announcer := Announcer new ]! !

!GTSpotter methodsFor: 'accessing' stamp: 'TudorGirba 11/26/2014 11:33'!
currentStep
	
	^ currentStep ifNil: [ 
			self isEmpty 
				ifTrue: [ self newStep origin: self foundationOrigin ]
				ifFalse: [ currentStep := self steps last ] ]! !

!GTSpotter methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/15/2014 15:34'!
currentStep: aStepModel
	
	currentStep := aStepModel.
	self notifyCurrentStepChanged! !

!GTSpotter methodsFor: 'actions api' stamp: 'TudorGirba 11/26/2014 14:34'!
exit

	self announcer announce: (GTSpotterExitAnnouncement new)! !

!GTSpotter methodsFor: 'accessing' stamp: 'AliaskeiSyrel 11/8/2014 17:12'!
foundationOrigin
	
	^ foundationOrigin ifNil: [ foundationOrigin := self ]! !

!GTSpotter methodsFor: 'accessing' stamp: 'AliaskeiSyrel 11/8/2014 16:36'!
foundationOrigin: anObject
	
	foundationOrigin := anObject! !

!GTSpotter methodsFor: 'model access' stamp: 'AliaskeiSyrel 11/13/2014 21:22'!
getText

	^ self text! !

!GTSpotter methodsFor: 'testing' stamp: 'TudorGirba 11/24/2014 12:23'!
hasPreviousStep

	^ self steps size > 1! !

!GTSpotter methodsFor: 'actions api' stamp: 'AliakseiSyrel 1/27/2015 11:48'!
hidePreview

	self isPreviewVisible ifFalse: [ ^ self ].
	isPreviewVisible := false.
	self announcer announce: GTSpotterHidePreview new.
	! !

!GTSpotter methodsFor: 'actions api' stamp: 'TudorGirba 12/3/2014 21:12'!
historize: target
	(target = self or: [ target isNil ])
		ifFalse: [ 
			self class history remove: target ifAbsent: [].
			self class history addFirst: target ]! !

!GTSpotter methodsFor: 'testing' stamp: 'AliaskeiSyrel 11/13/2014 20:41'!
isEmpty

	^ self steps isEmpty! !

!GTSpotter methodsFor: 'testing' stamp: 'AliakseiSyrel 1/26/2015 15:51'!
isPreviewVisible

	^ isPreviewVisible ifNil: [ isPreviewVisible := false ]! !

!GTSpotter methodsFor: 'protocol' stamp: 'AliakseiSyrel 10/24/2014 11:27'!
menu
	^ nil! !

!GTSpotter methodsFor: 'instance creation' stamp: 'TudorGirba 11/26/2014 14:35'!
newStep

	^ GTSpotterStep new 
		spotter: self! !

!GTSpotter methodsFor: 'notifying' stamp: 'TudorGirba 11/26/2014 14:34'!
notifyCurrentStepChanged

	self announcer announce: (GTSpotterCurrentStepChanged new)! !

!GTSpotter methodsFor: 'notifying' stamp: 'TudorGirba 11/26/2014 14:34'!
notifyStepAdded: aStep

	self announcer announce: (GTSpotterStepAdded new stepModel: aStep)! !

!GTSpotter methodsFor: 'notifying' stamp: 'TudorGirba 11/26/2014 14:34'!
notifyStepPopped

	self announcer announce: (GTSpotterStepPopped new)! !

!GTSpotter methodsFor: 'event handling' stamp: 'AliakseiSyrel 11/15/2014 16:21'!
onPagePopped
	
	self steps size > 0 ifTrue: [
		self currentStep: self steps last ]! !

!GTSpotter methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/15/2014 15:59'!
pagerModel

	^ pagerModel ifNil: [
		pagerModel := GLMPagerModel new defaultNumberOfVisiblePages: 1.
		pagerModel announcer subscribe: GLMPagePoped send: #onPagePopped to: self.
		pagerModel ]! !

!GTSpotter methodsFor: 'actions api' stamp: 'AliakseiSyrel 11/20/2014 13:36'!
popStep

	"there always should be minimum one step left"
	(self steps size > 1)
		ifTrue: [
			self steps removeLast.
			self notifyStepPopped.
			"perform pane popping only after we scrolled to the penultimate pane, so user doesn't see blinking"
			self pagerModel
				scrollToPane: (self steps size)
				callback: [ self pagerModel popPane: false ] ]! !

!GTSpotter methodsFor: 'accessing' stamp: 'TudorGirba 11/24/2014 12:23'!
previousStep
	
	^ self steps size > 1 
		ifTrue: [ self steps reversed second ]! !

!GTSpotter methodsFor: 'actions api' stamp: 'AliakseiSyrel 11/15/2014 15:40'!
pushStep: stepModel
	
	self addStep: stepModel.
	"updating current step"
	self currentStep: stepModel! !

!GTSpotter methodsFor: 'event handling' stamp: 'TudorGirba 11/24/2014 14:12'!
requestNextStepWith: origin
	text := ''.
	self pushStep: (self newStep origin: origin; yourself).
	self steps last process: nil.! !

!GTSpotter methodsFor: 'model access' stamp: 'AliakseiSyrel 11/20/2014 22:56'!
setText: aText from: aView

	self steps isEmpty
		"by default there are no steps, so we need to create one based on foundation origin"
		ifTrue: [ self addStep: ( self newStep origin: self foundationOrigin ) ].

	(aText asString isEmpty and: [ text isEmpty not ])
		ifTrue: [ self currentStep process: nil ]
		ifFalse: [ self currentStep process: aText asString ].
	
	text := aText asString asText.
	^ true! !

!GTSpotter methodsFor: 'actions api' stamp: 'AliakseiSyrel 1/27/2015 11:48'!
showPreview

	self isPreviewVisible ifTrue: [ ^ self ].
	isPreviewVisible := true.
	self announcer announce: GTSpotterShowPreview new.
	! !

!GTSpotter methodsFor: 'accessing' stamp: 'AliaskeiSyrel 11/13/2014 21:20'!
steps

	^ steps ifNil: [ steps := OrderedCollection new ]! !

!GTSpotter methodsFor: 'actions api' stamp: 'AliakseiSyrel 11/21/2014 23:50'!
terminateProcessors

	self steps do: [ :each | each terminateProcessors ]! !

!GTSpotter methodsFor: 'accessing' stamp: 'AliaskeiSyrel 11/13/2014 21:21'!
text

	^ text ifNil: [ text := '' asText ]! !

!GTSpotter methodsFor: 'actions api' stamp: 'AliakseiSyrel 1/26/2015 15:53'!
togglePreview

	self isPreviewVisible
		ifTrue: [ self hidePreview ]
		ifFalse: [ self showPreview ]! !

Object subclass: #GTSpotterCandidatesList
	instanceVariableNames: 'categories candidates announcer processorLinksMap'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Model'!

!GTSpotterCandidatesList commentStamp: 'TudorGirba 11/26/2014 15:08' prior: 0!
A model utility class that provides a way to handle the list of candidates shown in the spotter result.

The candidates are stored in a linked list.!

!GTSpotterCandidatesList methodsFor: 'adding/removing' stamp: 'TudorGirba 11/28/2014 11:47'!
addAllCandidates: aCollection in: aProcessor
	| allLinks |
	allLinks := OrderedCollection new.
	aCollection
		do: [ :each | 
			| processorLink candidateLink |
			processorLink := self getProcessorLink: aProcessor.
			candidateLink := each asSpotterCandidateLink processorLink: processorLink.	"if head is nil, it means there are no candidates yet"
			candidateLink := processorLink isEmpty
				ifTrue: [ self privateAddCandidate: candidateLink inEmpty: processorLink ]
				ifFalse: [ self privateAddCandidate: candidateLink inNotEmpty: processorLink ].
			self updateCycleConnectionFor: candidateLink.
			allLinks add: candidateLink ].
	self announcer announce:
			(GTSpotterAllCandidatesAdded new
				candidateLinks: allLinks;
				category: aProcessor;
				yourself)! !

!GTSpotterCandidatesList methodsFor: 'adding/removing' stamp: 'AliakseiSyrel 11/24/2014 22:24'!
addCandidate: anObjectOrLink in: aProcessor
	"before adding candidates we need to define all categories, because their order is important"
	|processorLink candidateLink|
	
	"processorLink is DoubleLink"
	processorLink := self getProcessorLink: aProcessor.
	
	candidateLink := anObjectOrLink asSpotterCandidateLink processorLink: processorLink.
	
	"if head is nil, it means there are no candidates yet"
	candidateLink := (processorLink isEmpty)
		ifTrue: [ self privateAddCandidate: candidateLink inEmpty: processorLink ]
		ifFalse: [ self privateAddCandidate: candidateLink inNotEmpty: processorLink ].
		
	self updateCycleConnectionFor: candidateLink.
	
	self notifyCandidateAdded: candidateLink in: aProcessor.
	
	^ candidateLink
	! !

!GTSpotterCandidatesList methodsFor: 'adding/removing' stamp: 'AliakseiSyrel 11/29/2014 14:28'!
addProcessor: aProcessor
	|processorLink|
	
	processorLink := aProcessor asSpotterProcessorLink.
	"linking processor with it's link"
	self processorLinksMap add: (aProcessor -> processorLink).
	self processors addLast: processorLink.
	
	^ processorLink! !

!GTSpotterCandidatesList methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/14/2014 21:33'!
announcer
	^ announcer ifNil: [ announcer := Announcer new ]! !

!GTSpotterCandidatesList methodsFor: 'accessing' stamp: 'TudorGirba 11/26/2014 14:34'!
candidates

	^ candidates ifNil: [ candidates := GTSpotterDoubleLinkedList new ]! !

!GTSpotterCandidatesList methodsFor: 'candidates' stamp: 'AliakseiSyrel 11/24/2014 20:35'!
getCandidateLink: aCandiate in: aProcessor
	"returns a corresponding candidateLink, that belongs to a processor"
	(self getCandidateLinks: (self getProcessorLink: aProcessor))
		do: [ :each | each value = aCandiate ifTrue: [ ^ each ] ].
	
	^ nil
	! !

!GTSpotterCandidatesList methodsFor: 'candidates' stamp: 'AliakseiSyrel 11/24/2014 20:36'!
getCandidateLinks: aProcessorLink
	"returns all candidate links that belongs to a processor link"
	|list head tail current|
	
	head := aProcessorLink headLink.
	tail := aProcessorLink tailLink.
	
	list := OrderedCollection new.
	head ifNil: [ ^ list ].
	(head = tail) ifTrue: [ list add: head. ^ list ].
	
	current := head.
	
	[ current = tail ] whileFalse: [
		list add: current.
		current := current nextLink ].
	"adding last one"
	list add: current.
	
	^ list
	! !

!GTSpotterCandidatesList methodsFor: 'processors' stamp: 'AliakseiSyrel 11/24/2014 20:28'!
getProcessorLink: aProcessor

	^ self processorLinksMap at: aProcessor ifAbsent: [ nil ]! !

!GTSpotterCandidatesList methodsFor: 'processors' stamp: 'AliakseiSyrel 11/24/2014 20:38'!
getProcessorLinkByCandidateLink: aCandidateLink

	^ aCandidateLink processorLink! !

!GTSpotterCandidatesList methodsFor: 'candidates' stamp: 'AliakseiSyrel 11/14/2014 15:54'!
head

	^ self candidates head! !

!GTSpotterCandidatesList methodsFor: 'testing' stamp: 'AliakseiSyrel 11/14/2014 15:49'!
isEmpty

	^ self candidates isEmpty! !

!GTSpotterCandidatesList methodsFor: 'processors' stamp: 'AliakseiSyrel 11/24/2014 20:52'!
nextProcessorLinkOf: aProcessorLink
	"returns next processor link, that has more than zero candidates.
	if passed processor is the last one, will continue searching from the beginning"
	|current|
	aProcessorLink ifNil: [ ^ aProcessorLink ].
	
	current := aProcessorLink nextLink.
	current ifNil: [ current := self processors head ].
	
	[ current = aProcessorLink ] whileFalse: [
		(current isEmpty) ifFalse: [ ^ current ].
		current := current nextLink.
		current ifNil: [ current := self processors head ].
	].

	^ aProcessorLink
	! !

!GTSpotterCandidatesList methodsFor: 'notifying' stamp: 'AliakseiSyrel 11/29/2014 14:40'!
notifyAllCandidatesRemoved

	self announcer announce: (GTSpotterAllCandidatesRemoved new)! !

!GTSpotterCandidatesList methodsFor: 'notifying' stamp: 'TudorGirba 11/26/2014 14:34'!
notifyAmountChanged: anInteger in: aProcessor
	
	self announcer announce: (GTSpotterCandidatesAmountChanged new amount: anInteger; category: aProcessor; yourself)! !

!GTSpotterCandidatesList methodsFor: 'notifying' stamp: 'TudorGirba 11/26/2014 14:34'!
notifyCandidateAdded: aCandidateLink in: aProcessor

	self announcer announce: (GTSpotterCandidateAdded new candidateLink: aCandidateLink; category: aProcessor; yourself).! !

!GTSpotterCandidatesList methodsFor: 'stream handling' stamp: 'TudorGirba 11/26/2014 14:34'!
onAmountChanged: anInteger in: aProcessor
	
	self announcer announce: (GTSpotterCandidatesAmountChanged new amount: anInteger; category: aProcessor; yourself)! !

!GTSpotterCandidatesList methodsFor: 'processors' stamp: 'AliakseiSyrel 11/24/2014 20:52'!
previousProcessorLinkOf: aProcessorLink
	"returns previous processor link, that has more than zero candidates.
	if passed processor is the first one, will continue searching from the end"
	|current|
	aProcessorLink ifNil: [ ^ aProcessorLink ].
	
	current := aProcessorLink previousLink.
	current ifNil: [ current := self processors tail ].
	
	[ current = aProcessorLink ] whileFalse: [
		(current isEmpty) ifFalse: [ ^ current ].
		current := current previousLink.
		current ifNil: [ current := self processors tail ].
	].

	^ aProcessorLink
	! !

!GTSpotterCandidatesList methodsFor: 'private' stamp: 'AliakseiSyrel 11/24/2014 22:31'!
privateAddCandidate: aCandidateLink inEmpty: aProcessorLink
	| head current |
		
	current := aProcessorLink.	"not nil"
	head := nil.						"nil"
	[ head isNil and: [ current isNotNil ]] whileTrue: [	
		current := current nextLink.	"next category"
		"head of next category if not nil break loop"
		current ifNotNil: [ head := current headLink ] ifNil: [ nil ] ].
	
	"means all next categories are empty, just add to the end"
	current
		ifNil: [ self candidates addLast: aCandidateLink ]
		ifNotNil: [ self candidates add: aCandidateLink beforeLink: head ].
		aProcessorLink
			headLink: aCandidateLink;
			tailLink: aCandidateLink.
			
		aProcessorLink incrementSize.
		
	^ aCandidateLink! !

!GTSpotterCandidatesList methodsFor: 'private' stamp: 'AliakseiSyrel 11/24/2014 23:31'!
privateAddCandidate: aCandidateLink inNotEmpty: aProcessorLink
	
	"aCandidateLink weight
		ifNotNil: [ ^ self privateAddCandidate: aCandidateLink weightedIn: aProcessorLink ]."
	
	self candidates add: aCandidateLink afterLink: (aProcessorLink tailLink).
	aProcessorLink incrementSize.
	"updating category tail"
	aProcessorLink tailLink: aCandidateLink.
	^ aCandidateLink! !

!GTSpotterCandidatesList methodsFor: 'private' stamp: 'AliakseiSyrel 11/24/2014 22:36'!
privateAddCandidate: aCandidateLink weightedIn: aProcessorLink

	^ aProcessorLink isFull
		ifTrue: [ self privateAddCandidate: aCandidateLink weightedInFull: aProcessorLink ]
		ifFalse: [ self privateAddCandidate: aCandidateLink weightedInNotFull: aProcessorLink ]! !

!GTSpotterCandidatesList methodsFor: 'private' stamp: 'AliakseiSyrel 11/24/2014 22:34'!
privateAddCandidate: aCandidateLink weightedInFull: aProcessorLink

	! !

!GTSpotterCandidatesList methodsFor: 'private' stamp: 'AliakseiSyrel 11/24/2014 22:54'!
privateAddCandidate: aCandidateLink weightedInNotFull: aProcessorLink
	|head tail|
	
	head := aProcessorLink headLink.
	tail := aProcessorLink tailLink.

	"fast check if we need to add it before first"
	(aCandidateLink weight > head weight)
		ifTrue: [ head := self candidates add: aCandidateLink beforeLink: head ]
		ifFalse: [
	"fast check if we need to add it after the last"
	(aCandidateLink weight > tail weight)
		ifFalse: [ tail := self candidates add: aCandidateLink afterLink: tail ]
		ifTrue: [  ] ]! !

!GTSpotterCandidatesList methodsFor: 'accessing' stamp: 'AliakseiSyrel 12/9/2014 13:51'!
processorLinksMap

	^ processorLinksMap ifNil: [ processorLinksMap := Dictionary new ]
	! !

!GTSpotterCandidatesList methodsFor: 'accessing' stamp: 'TudorGirba 11/26/2014 14:34'!
processors

	^ categories ifNil: [ categories := GTSpotterDoubleLinkedList new ].! !

!GTSpotterCandidatesList methodsFor: 'adding/removing' stamp: 'AliakseiSyrel 11/29/2014 14:44'!
removeAllCandidates

	self processors linksDo: [ :each | each clear ].
	self candidates removeAll.
	self notifyAllCandidatesRemoved
	
	
	
	
	! !

!GTSpotterCandidatesList methodsFor: 'adding/removing' stamp: 'AliakseiSyrel 11/29/2014 14:41'!
removeAllCandidatesOf: aProcessor
	|processorLink head tail current|
	
	processorLink := self getProcessorLink: aProcessor.
	
	(processorLink isEmpty) ifTrue: [ ^ self ].
	
	head := processorLink headLink.
	tail := processorLink tailLink.
		
	(head = tail) ifTrue: [
		self candidates removeCycledLink: head.
		processorLink clear. ].
	
	current := head.
	[ current = tail ] whileFalse: [ |nextCurrent|
		nextCurrent := current nextLink.
		self candidates removeCycledLink: current.
		current := nextCurrent ].
	
	self candidates removeCycledLink: current.
	
	processorLink clear.
	
	
	
	
	
	! !

!GTSpotterCandidatesList methodsFor: 'candidates' stamp: 'AliakseiSyrel 11/15/2014 13:08'!
tail

	^ self candidates tail! !

!GTSpotterCandidatesList methodsFor: 'candidates' stamp: 'AliakseiSyrel 11/24/2014 20:53'!
updateCycleConnectionFor: aCandidateLink

	"if link is the last setting nextLink to head"
	(self candidates tail = aCandidateLink) ifTrue: [
		aCandidateLink nextLink: self candidates head.
		self candidates head previousLink: aCandidateLink ].
	
	"if link is the first setting previousLink to tail"
	(self candidates head = aCandidateLink) ifTrue: [
		aCandidateLink previousLink: self candidates tail.
		self candidates tail nextLink: aCandidateLink ].! !

Object subclass: #GTSpotterProcessor
	instanceVariableNames: 'allFilteredCandidates'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Processors'!

!GTSpotterProcessor commentStamp: 'TudorGirba 11/26/2014 15:12' prior: 0!
This is the abstract class that models a processor that is associated with a spotter category. It can spot items to be displayed in that category by reacting to a filter: message. !

GTSpotterProcessor subclass: #GTSpotterCandidatesProcessor
	instanceVariableNames: 'origin allCandidates'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Processors'!

!GTSpotterCandidatesProcessor commentStamp: 'TudorGirba 11/30/2014 22:12' prior: 0!
This processor adds the ability of computing and caching all possible candidates. It is useful when we know all candidates upfront.!

GTSpotterCandidatesProcessor subclass: #GTSpotterCandidatesListProcessor
	instanceVariableNames: 'allCandidatesBlock candidatesLimit queryMatchingBlock title itemNameBlock itemIconBlock actBlock wantsToDisplayOnEmptyQuery filterBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Processors'!

!GTSpotterCandidatesListProcessor commentStamp: 'TudorGirba 11/30/2014 22:12' prior: 0!
This is a candidates processor that can be parameterized via blocks.!

!GTSpotterCandidatesListProcessor methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/21/2014 13:56'!
actLogic: aBlockWithTwoArguments

	actBlock := aBlockWithTwoArguments! !

!GTSpotterCandidatesListProcessor methodsFor: 'scripting' stamp: 'AliakseiSyrel 11/21/2014 13:57'!
actOn: anObject for: aStep
	
	actBlock
		ifNil: [ super actOn: anObject for: aStep ]
		ifNotNil: [ actBlock cull: anObject cull: aStep ]! !

!GTSpotterCandidatesListProcessor methodsFor: 'scripting' stamp: 'TudorGirba 11/16/2014 13:35'!
allCandidates: aBlockWithOneArgument
	allCandidatesBlock := aBlockWithOneArgument ! !

!GTSpotterCandidatesListProcessor methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/18/2014 23:16'!
candidatesLimit
	^ candidatesLimit ifNil: [ 5 ]! !

!GTSpotterCandidatesListProcessor methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/18/2014 23:16'!
candidatesLimit: anInteger
	candidatesLimit := anInteger! !

!GTSpotterCandidatesListProcessor methodsFor: 'accessing' stamp: 'TudorGirba 11/18/2014 20:40'!
computeCandidates
	^ allCandidatesBlock cull: self origin! !

!GTSpotterCandidatesListProcessor methodsFor: 'accessing' stamp: 'TudorGirba 11/26/2014 14:12'!
doFilter: aStringQuery on: aStream
	^ filterBlock isNil
		ifTrue: [ super doFilter: aStringQuery on: aStream ]
		ifFalse: [ filterBlock value: aStringQuery value: aStream ]! !

!GTSpotterCandidatesListProcessor methodsFor: 'scripting' stamp: 'TudorGirba 11/26/2014 14:13'!
filter: aBlockWithTwoArguments
	filterBlock := aBlockWithTwoArguments ! !

!GTSpotterCandidatesListProcessor methodsFor: 'accessing' stamp: 'TudorGirba 11/17/2014 08:33'!
is: anObject matching: aString
	^ queryMatchingBlock 
		value: anObject
		value: aString! !

!GTSpotterCandidatesListProcessor methodsFor: 'scripting' stamp: 'TudorGirba 11/21/2014 11:14'!
itemIcon: aBlockWithOneArgument
	itemIconBlock := aBlockWithOneArgument! !

!GTSpotterCandidatesListProcessor methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/21/2014 13:33'!
itemIconFor: anObject
	^ itemIconBlock isNil
		ifTrue: [ super itemIconFor: anObject ]
		ifFalse: [ itemIconBlock cull: anObject ]! !

!GTSpotterCandidatesListProcessor methodsFor: 'scripting' stamp: 'TudorGirba 11/17/2014 23:26'!
itemName: aBlockWithOneArgument
	itemNameBlock := aBlockWithOneArgument! !

!GTSpotterCandidatesListProcessor methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/21/2014 13:34'!
itemNameFor: anObject
	^ itemNameBlock isNil
		ifTrue: [ super itemNameFor: anObject ]
		ifFalse: [ itemNameBlock cull: anObject ]! !

!GTSpotterCandidatesListProcessor methodsFor: 'accessing' stamp: 'TudorGirba 11/16/2014 13:06'!
matchLogic: aBlockWithTwoArguments
	queryMatchingBlock := aBlockWithTwoArguments! !

!GTSpotterCandidatesListProcessor methodsFor: 'scripting' stamp: 'AliakseiSyrel 12/10/2014 22:06'!
matchSubstring
	self filter: [ :originalQuery :stream |
		| prefixMatchers rest query |
		"if filter is empty we stream all candidates"
		query := originalQuery trimBoth asLowercase.
		query isEmpty 
			ifTrue: [ self streamAllCandidatesOn: stream ]
			ifFalse: [
				prefixMatchers := OrderedCollection  new.
				rest := OrderedCollection new.
				self allCandidates do: [:each | 
					| index |
					index := (self itemNameFor: each) findString: query startingAt: 1 caseSensitive: false.
					index >= 1 ifTrue: [
						index = 1 
							ifTrue: [ 
									prefixMatchers add: each.
									prefixMatchers size > self candidatesLimit ifFalse: [ 
										stream addObject: each inProcessor: self ]]
							ifFalse: [ rest add: each ]]].
				(prefixMatchers size < self candidatesLimit) ifTrue: [ 
					(rest first: ((self candidatesLimit - prefixMatchers size) min: rest size)) do: [ :each |
						stream addObject: each inProcessor: self ] ].
				prefixMatchers , rest ] ]! !

!GTSpotterCandidatesListProcessor methodsFor: 'accessing' stamp: 'TudorGirba 11/26/2014 14:23'!
title
	^ title ifNil: [ super title ]! !

!GTSpotterCandidatesListProcessor methodsFor: 'scripting' stamp: 'TudorGirba 11/26/2014 14:23'!
title: aString
	title := aString! !

!GTSpotterCandidatesListProcessor methodsFor: 'accessing' stamp: 'TudorGirba 11/25/2014 22:42'!
wantsToDisplayOnEmptyQuery
	^ wantsToDisplayOnEmptyQuery ifNil: [ super wantsToDisplayOnEmptyQuery ]! !

!GTSpotterCandidatesListProcessor methodsFor: 'accessing' stamp: 'TudorGirba 11/25/2014 22:40'!
wantsToDisplayOnEmptyQuery: anObject
	wantsToDisplayOnEmptyQuery := anObject! !

!GTSpotterCandidatesProcessor class methodsFor: 'instance creation' stamp: 'AliaskeiSyrel 11/8/2014 11:06'!
on: anObject

	^ self new origin: anObject! !

!GTSpotterCandidatesProcessor methodsFor: 'accessing' stamp: 'TudorGirba 11/17/2014 21:35'!
allCandidates

	^ allCandidates ifNil: [ allCandidates := self computeCandidates copy ].! !

!GTSpotterCandidatesProcessor methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/18/2014 23:16'!
candidatesLimit
	"Return the maximal number of elements that can be found during search.
	Default implementation returns infinity, so the number of element is not limited."
	^ Float infinity! !

!GTSpotterCandidatesProcessor methodsFor: 'defaults' stamp: 'TudorGirba 11/17/2014 21:34'!
computeCandidates

	^ OrderedCollection new
	! !

!GTSpotterCandidatesProcessor methodsFor: 'accessing' stamp: 'AliakseiSyrel 12/2/2014 19:51'!
doFilter: aStringQuery on: aStream
	| mResults|
	
	"if filter is empty we stream all candidates"
	aStringQuery isEmpty ifTrue: [ ^ self streamAllCandidatesOn: aStream ].
	
	mResults := OrderedCollection new.
	
	self allCandidates do: [ :each |
		(self is: each matching: aStringQuery) ifTrue: [
			mResults isEmpty ifTrue: [ Processor activeProcess priority: Processor userSchedulingPriority ].
			
			(mResults size >= self candidatesLimit)
				ifTrue: [ mResults size = self candidatesLimit ifTrue: [ Processor activeProcess priority: Processor userBackgroundPriority  ] ]
				ifFalse: [ aStream addObject: each inProcessor: self ].
				
			mResults add: each.
		] ].

	^ mResults! !

!GTSpotterCandidatesProcessor methodsFor: 'filtering/searching' stamp: 'TudorGirba 11/17/2014 08:33'!
is: anObject matching: aString
	"Returns true if anObject matches a provided string, otherwise false.
	Default implementation matches string representation of an object with passed value"
	^ anObject asString includesSubstring: aString caseSensitive: false! !

!GTSpotterCandidatesProcessor methodsFor: 'filtering/searching' stamp: 'TudorGirba 11/27/2014 10:42'!
itemIconFor: anObject
	^ nil! !

!GTSpotterCandidatesProcessor methodsFor: 'filtering/searching' stamp: 'TudorGirba 11/26/2014 14:19'!
itemNameFor: anObject
	^ anObject gtDisplayString! !

!GTSpotterCandidatesProcessor methodsFor: 'accessing' stamp: 'AliaskeiSyrel 11/8/2014 09:19'!
origin

	^ origin! !

!GTSpotterCandidatesProcessor methodsFor: 'accessing' stamp: 'AliaskeiSyrel 11/1/2014 20:13'!
origin: anObject

	origin := anObject! !

!GTSpotterCandidatesProcessor methodsFor: 'filtering/searching' stamp: 'TudorGirba 11/26/2014 14:34'!
render: anObject
	^ GTSpotterItemBrick new
		icon: (self itemIconFor: anObject);
		text: (self itemNameFor: anObject)! !

!GTSpotterCandidatesProcessor methodsFor: 'private' stamp: 'TudorGirba 11/27/2014 22:46'!
streamAllCandidatesOn: aStream
	aStream
				addObjects: (self allCandidates first: (self candidatesLimit min: self allCandidates size))
				inProcessor: self.
	^ self allCandidates! !

!GTSpotterCandidatesProcessor methodsFor: 'filtering/searching' stamp: 'TudorGirba 11/26/2014 14:20'!
title
	^ 'undefined'! !

!GTSpotterProcessor methodsFor: 'public' stamp: 'TudorGirba 11/25/2014 11:40'!
actOn: anObject for: aStep
	aStep exit.	
	anObject spotterActDefault.
! !

!GTSpotterProcessor methodsFor: 'public' stamp: 'TudorGirba 11/24/2014 23:51'!
allFilteredCandidates
	^ allFilteredCandidates ifNil: [ allFilteredCandidates := OrderedCollection new ]! !

!GTSpotterProcessor methodsFor: 'public' stamp: 'TudorGirba 11/24/2014 23:19'!
doFilter: aStringQuery on: aStream
	"override this method to:
	- add items to the stream
	- return all found items at the end"
	self subclassResponsibility! !

!GTSpotterProcessor methodsFor: 'public' stamp: 'AliakseiSyrel 11/29/2014 14:46'!
filter: aStringQuery on: aStream
	
	allFilteredCandidates := nil.
	(aStringQuery notEmpty or: [ self wantsToDisplayOnEmptyQuery ]) ifTrue: [
		allFilteredCandidates := self doFilter: aStringQuery on: aStream ].
	aStream 
		performSymbol: #onAmountChanged:in: 
		withArguments: { self allFilteredCandidates size . self }! !

!GTSpotterProcessor methodsFor: 'ui' stamp: 'TudorGirba 11/26/2014 14:34'!
render: anObject
	^ GTSpotterItemBrick new
		icon: (nil);
		text: (anObject gtDisplayString)! !

!GTSpotterProcessor methodsFor: 'accessing' stamp: 'TudorGirba 11/26/2014 14:20'!
title
	self subclassResponsibility! !

!GTSpotterProcessor methodsFor: 'testing' stamp: 'TudorGirba 11/25/2014 14:19'!
wantsToDisplayOnEmptyQuery
	^ true! !

Object subclass: #GTSpotterStep
	instanceVariableNames: 'announcer processors origin query selected stream candidates asyncTask spotter isCategorySelected'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Model'!

!GTSpotterStep commentStamp: 'TudorGirba 11/26/2014 15:13' prior: 0!
It models one step in the spotter search.

A step knows:
- the origin object 
- the active processors that handle the query, and the candidates
- the selected candidate, and
- the list of all filtered candidates

It also knows the stream through which the list of candidates is affected.

The key method is process:!

!GTSpotterStep methodsFor: 'actions' stamp: 'AliakseiSyrel 12/10/2014 23:49'!
act
	|processor|
	self selected ifNil: [ ^ self ].
	processor := (self candidates getProcessorLinkByCandidateLink: self selected) processor.
	self spotter historize: self selected.
	processor actOn: self selectedCandidate for: self.
! !

!GTSpotterStep methodsFor: 'accessing' stamp: 'TudorGirba 11/18/2014 21:07'!
addProcessor: aProcessor

	self processors add: aProcessor! !

!GTSpotterStep methodsFor: 'accessing' stamp: 'AliaskeiSyrel 11/8/2014 10:26'!
announcer

	^ announcer ifNil: [ announcer := Announcer new ]! !

!GTSpotterStep methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/30/2014 21:02'!
asyncTask

	^ asyncTask ifNil: [ asyncTask := GTAsyncTask new ]! !

!GTSpotterStep methodsFor: 'actions' stamp: 'TudorGirba 12/1/2014 14:32'!
canDiveIn: aCandidate
	| newFakeStep |
	newFakeStep := self spotter newStep origin: self origin.
	aCandidate spotterProcessorsFor: newFakeStep.
	^ newFakeStep processors notEmpty! !

!GTSpotterStep methodsFor: 'actions' stamp: 'AliakseiSyrel 11/27/2014 12:34'!
canDiveInSelectedCandidate

	^ self canDiveIn: self selectedCandidate! !

!GTSpotterStep methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/30/2014 21:28'!
candidates

	^ candidates ifNil: [
		candidates := GTSpotterCandidatesList new.
		candidates announcer subscribe: GTSpotterCandidateAdded do: [ self selectFirst ].
		candidates announcer subscribe: GTSpotterAllCandidatesAdded do: [ self selectFirst ].
		candidates ]! !

!GTSpotterStep methodsFor: 'actions' stamp: 'AliakseiSyrel 12/11/2014 00:01'!
diveIn
	self canDiveInSelectedCandidate ifTrue: [ 
		self spotter historize: self selected.
		self spotter requestNextStepWith: self selectedCandidate ]! !

!GTSpotterStep methodsFor: 'actions' stamp: 'AliakseiSyrel 12/20/2014 18:26'!
diveInCategory
	| processorLink |
	processorLink := (self candidates getProcessorLinkByCandidateLink: self selected).
	self spotter requestNextStepWith: (processorLink processor allFilteredCandidates collect: [ :each | each asSpotterCandidateLink renderingProcessor: processorLink ])! !

!GTSpotterStep methodsFor: 'actions' stamp: 'TudorGirba 11/24/2014 14:13'!
exit
	self spotter exit! !

!GTSpotterStep methodsFor: 'testing' stamp: 'AliakseiSyrel 12/11/2014 12:12'!
isCategorySelected

	^ isCategorySelected ifNil: [ isCategorySelected := Morph new activeHand shiftPressed ]! !

!GTSpotterStep methodsFor: 'testing' stamp: 'AliakseiSyrel 11/14/2014 23:51'!
isEmpty

	^ self candidates isEmpty! !

!GTSpotterStep methodsFor: 'accessing' stamp: 'TudorGirba 11/26/2014 14:34'!
listProcessor
	| processor |
	processor := GTSpotterCandidatesListProcessor new.
	self addProcessor: processor.
	^ processor! !

!GTSpotterStep methodsFor: 'notifying' stamp: 'AliakseiSyrel 12/11/2014 12:06'!
notifyCategorySelectedOrDeselected

	self isCategorySelected
		ifTrue: [ self announcer announce: GTSpotterCategorySelected new ]
		ifFalse: [ self announcer announce: GTSpotterCategoryDeselected new ]! !

!GTSpotterStep methodsFor: 'notifying' stamp: 'AliakseiSyrel 1/20/2015 12:40'!
notifySelectedCandidateChanged

	self announcer announce: (GTSpotterSelectedCandidateChanged new selected: self selectedCandidate).
	self spotter announcer announce: (GTSpotterSelectedCandidateChanged new selected: self selectedCandidate).! !

!GTSpotterStep methodsFor: 'accessing' stamp: 'AliaskeiSyrel 11/8/2014 10:26'!
origin

	^ origin! !

!GTSpotterStep methodsFor: 'accessing' stamp: 'AliaskeiSyrel 11/8/2014 17:13'!
origin: anObject

	origin := anObject! !

!GTSpotterStep methodsFor: 'processing' stamp: 'AliakseiSyrel 1/28/2015 11:43'!
process: aString
	"I do not accept empty queries or the same queries as before.
	If nil is passed, than an empty string will be processed. This approach is used to
	destinguish when user deletes last character in the search and when search field became
	empty after spawning new step"
	
	"no need to search for the same query"
	(self query isNotEmpty and: [ aString = self query ]) ifTrue: [ ^ self ].
	
	self query: (aString ifNil: [ '' ]).
	"updating timestamp in a stream, to prevent candidates from old process being shown"
	self stream updateTimestamp.
	
	self asyncTask
		execute: [ :input |
				self stream removeAllCandidates.
				self relevantProcessorsProcess: input ]
		withArguments: { self query }
		callback: [  ]
		"added small delay before actual searching. It makes spotter faster :)"
		delay: 200! !

!GTSpotterStep methodsFor: 'accessing' stamp: 'TudorGirba 11/24/2014 23:21'!
processors

	^ processors ifNil: [ 
		processors := OrderedCollection new.
		self origin spotterProcessorsFor: self.
		"this is a hack. we do it here just because we need to store the
		category name in the brick after the processors have been created"
		processors do: [ :each | 				
			self candidates addProcessor: each ].
		processors ]! !

!GTSpotterStep methodsFor: 'accessing' stamp: 'AliaskeiSyrel 11/8/2014 10:27'!
processors: aCollection

	processors := aCollection! !

!GTSpotterStep methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/15/2014 14:53'!
query

	^ query ifNil: [ query := '' ]! !

!GTSpotterStep methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/15/2014 14:53'!
query: aString

	query := aString! !

!GTSpotterStep methodsFor: 'accessing' stamp: 'TudorGirba 12/14/2014 15:21'!
relevantProcessorsFor: aQueryString do: aBlock
	aQueryString substrings 
		detect: [ :each | each beginsWith: '#' ]
		ifFound: [ :categoryQuery | 
			self processors 
				select: [ :each | each title beginsWith: categoryQuery allButFirst ]
				thenDo: [ :processor | 
					processor 
						filter: (aQueryString copyReplaceAll: categoryQuery with: '') 
						on: self stream ] ]
		ifNone: [ 
			self processors do: [ :processor | 
				processor 
					filter: aQueryString 
					on: self stream ]]! !

!GTSpotterStep methodsFor: 'accessing' stamp: 'TudorGirba 12/14/2014 16:29'!
relevantProcessorsProcess: aQueryString
	aQueryString substrings 
		detect: [ :each | each beginsWith: '#' ]
		ifFound: [ :categoryQuery | 
			self processors 
				select: [ :each | each title asLowercase beginsWith: categoryQuery allButFirst asLowercase ]
				thenDo: [ :processor | 
					processor 
						filter: (aQueryString copyReplaceAll: categoryQuery with: '') 
						on: self stream ] ]
		ifNone: [ 
			self processors do: [ :processor | 
				processor 
					filter: aQueryString 
					on: self stream ]]! !

!GTSpotterStep methodsFor: 'selecting' stamp: 'AliakseiSyrel 11/15/2014 13:58'!
selectFirst
	
	self candidates isEmpty ifTrue: [ ^ self ].
	
	selected := self candidates head.
	self notifySelectedCandidateChanged.! !

!GTSpotterStep methodsFor: 'selecting' stamp: 'AliakseiSyrel 11/14/2014 19:41'!
selectNext
	
	self selected ifNil: [ ^ self ].
	
	selected := self selected nextLink.
	self notifySelectedCandidateChanged.
	
	! !

!GTSpotterStep methodsFor: 'selecting' stamp: 'AliakseiSyrel 11/24/2014 20:38'!
selectNextCategory
	|currentCategory nextCategory|
	self selected ifNil: [ ^ self ].
	
	currentCategory := self candidates getProcessorLinkByCandidateLink: self selected.
	nextCategory := self candidates nextProcessorLinkOf: currentCategory.
	
	selected := (currentCategory = nextCategory)
		ifTrue: [ nextCategory tailLink ]
		ifFalse: [ nextCategory headLink ].
	
	self notifySelectedCandidateChanged.
	
	! !

!GTSpotterStep methodsFor: 'selecting' stamp: 'AliakseiSyrel 11/14/2014 19:41'!
selectPrevious

	self selected ifNil: [ ^ self ].
	
	selected := self selected previousLink.
	self notifySelectedCandidateChanged.! !

!GTSpotterStep methodsFor: 'selecting' stamp: 'AliakseiSyrel 11/24/2014 20:38'!
selectPreviousCategory
	|currentCategory previousCategory|
	self selected ifNil: [ ^ self ].
	
	currentCategory := self candidates getProcessorLinkByCandidateLink: self selected.
	previousCategory := self candidates previousProcessorLinkOf: currentCategory.
	
	selected := previousCategory headLink.
	
	self notifySelectedCandidateChanged.
	
	! !

!GTSpotterStep methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/14/2014 23:51'!
selected

	^ selected ifNil: [
		selected := self candidates isEmpty
			ifTrue: [ nil ]
			ifFalse: [ self candidates head ] ]! !

!GTSpotterStep methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/19/2014 00:07'!
selected: aDoubleLink

	selected := aDoubleLink.
	self notifySelectedCandidateChanged! !

!GTSpotterStep methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/14/2014 16:00'!
selectedCandidate

	^ self selected
		ifNotNil: [ self selected value ]
		ifNil: [ nil ]! !

!GTSpotterStep methodsFor: 'accessing' stamp: 'AliakseiSyrel 12/11/2014 12:15'!
selectedCategory

	^ self selected processor! !

!GTSpotterStep methodsFor: 'actions' stamp: 'AliakseiSyrel 12/11/2014 12:06'!
shiftPressed

	isCategorySelected := self isCategorySelected not.
	self notifyCategorySelectedOrDeselected! !

!GTSpotterStep methodsFor: 'accessing' stamp: 'TudorGirba 11/24/2014 10:15'!
spotter
	^ spotter! !

!GTSpotterStep methodsFor: 'accessing' stamp: 'TudorGirba 11/24/2014 10:14'!
spotter: aSpotter
	spotter := aSpotter ! !

!GTSpotterStep methodsFor: 'accessing' stamp: 'TudorGirba 11/26/2014 14:35'!
stream

	^ stream ifNil: [
		stream := GTSpotterUIThreadStream new.
		stream
			onAddedSelector: #addCandidate:in:;
			onRemoveSelector: #removeAllCandidatesOf:;
			receiver: self candidates.
		stream ]! !

!GTSpotterStep methodsFor: 'actions' stamp: 'AliakseiSyrel 11/30/2014 21:02'!
terminateProcessors

	self asyncTask terminate! !

Object subclass: #GTSpotterUIThreadStream
	instanceVariableNames: 'onAddedSelector onRemoveSelector receiver timestamp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Utils'!

!GTSpotterUIThreadStream methodsFor: 'adding/removing' stamp: 'AliakseiSyrel 12/10/2014 22:11'!
addObject: firstObject inProcessor: secondObject

	self performSymbol: self onAddedSelector withArguments: { firstObject. secondObject }.
	Processor yield! !

!GTSpotterUIThreadStream methodsFor: 'adding/removing' stamp: 'AliakseiSyrel 12/10/2014 22:12'!
addObjects: aCollection inProcessor: aProcessor

	self performSymbol: #addAllCandidates:in: withArguments: { aCollection . aProcessor }.
	Processor yield! !

!GTSpotterUIThreadStream methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/14/2014 20:05'!
onAddedSelector
	^ onAddedSelector! !

!GTSpotterUIThreadStream methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/14/2014 20:05'!
onAddedSelector: anObject
	onAddedSelector := anObject! !

!GTSpotterUIThreadStream methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/14/2014 20:54'!
onRemoveSelector
	^ onRemoveSelector! !

!GTSpotterUIThreadStream methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/14/2014 20:54'!
onRemoveSelector: anObject
	onRemoveSelector := anObject! !

!GTSpotterUIThreadStream methodsFor: 'performing' stamp: 'AliakseiSyrel 11/30/2014 22:44'!
performSymbol: aSymbol withArguments: aCollection
	|time|
	"we save current timestamp here, so that defer block can check if it belongs to the correct task"
	time := self timestamp.
	"UI manages commands for us"
	Processor yield.
	"if timestamp is wrong just skip command"
	UIManager default defer: [ time = self timestamp ifTrue: [ self receiver perform: aSymbol withEnoughArguments: aCollection ] ]! !

!GTSpotterUIThreadStream methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/14/2014 20:05'!
receiver
	^ receiver! !

!GTSpotterUIThreadStream methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/14/2014 20:05'!
receiver: anObject
	receiver := anObject! !

!GTSpotterUIThreadStream methodsFor: 'adding/removing' stamp: 'AliakseiSyrel 12/10/2014 22:12'!
removeAllCandidates

	self performSymbol: #removeAllCandidates withArguments: { }.
	Processor yield! !

!GTSpotterUIThreadStream methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/30/2014 22:38'!
timestamp
	^ timestamp! !

!GTSpotterUIThreadStream methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/30/2014 22:38'!
timestamp: anObject
	timestamp := anObject! !

!GTSpotterUIThreadStream methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 11/30/2014 22:39'!
updateTimestamp

	self timestamp: Time microsecondClockValue! !

Object subclass: #GTSpotterWidgetThemer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Theme'!

!GTSpotterWidgetThemer commentStamp: 'TudorGirba 11/26/2014 15:15' prior: 0!
This is a themer for all spotter morphs.

To customize it, it has to be subclassed and pointed to from:
ACustomTheme>>spotterWidgetThemer!

GTSpotterWidgetThemer subclass: #GTSpotterWidgetDarkThemer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-Theme'!

!GTSpotterWidgetDarkThemer commentStamp: 'AliakseiSyrel 1/23/2015 12:56' prior: 0!
A GTSpotterWidgetDarkThemer isasdasdasd xxasdasda!

!GTSpotterWidgetDarkThemer methodsFor: 'values' stamp: 'AliakseiSyrel 1/23/2015 13:18'!
backgroundColor
	"used as background color for all panes"
	^ Color r: 0.3 g: 0.3 b: 0.3! !

!GTSpotterWidgetDarkThemer methodsFor: 'values' stamp: 'AliakseiSyrel 1/23/2015 12:59'!
borderColor
	"color that is used for border and dividers of UI parts of Spotter
	for example divider between header and results or between preview and list"
	^ self backgroundColor darker! !

!GTSpotterWidgetDarkThemer methodsFor: 'acessing' stamp: 'AliakseiSyrel 1/26/2015 14:05'!
brickThemer

	^ GTSpotterBrickDarkThemer default! !

!GTSpotterWidgetDarkThemer methodsFor: 'values' stamp: 'AliakseiSyrel 1/23/2015 13:03'!
categoryTitleBackgroundColor

	^ self backgroundColor alpha: 0.95! !

!GTSpotterWidgetDarkThemer methodsFor: 'values' stamp: 'AliakseiSyrel 1/23/2015 13:20'!
itemActionSelectedBackgroundColor

	^ self itemSelectedBackgroundColor slightlyDarker! !

!GTSpotterWidgetDarkThemer methodsFor: 'values' stamp: 'AliakseiSyrel 1/23/2015 13:06'!
itemIconAlphaValue

	^ 0.5! !

!GTSpotterWidgetDarkThemer methodsFor: 'values' stamp: 'AliakseiSyrel 1/23/2015 13:09'!
itemSelectedBackgroundColor

	^ self backgroundColor slightlyDarker! !

!GTSpotterWidgetDarkThemer methodsFor: 'values' stamp: 'AliakseiSyrel 1/23/2015 13:10'!
itemTextColor

	^ Color white slightlyDarker! !

!GTSpotterWidgetDarkThemer methodsFor: 'values' stamp: 'AliakseiSyrel 1/23/2015 13:23'!
searchFieldCursorColor

	^ Color white alpha: 0.5! !

!GTSpotterWidgetDarkThemer methodsFor: 'values' stamp: 'AliakseiSyrel 1/23/2015 13:13'!
searchFieldTextColor
	
	^ Color white slightlyDarker! !

!GTSpotterWidgetDarkThemer methodsFor: 'values' stamp: 'AliakseiSyrel 1/23/2015 13:08'!
titleTextColor

	^ self backgroundColor muchLighter! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'AliakseiSyrel 11/24/2014 23:18'!
backgroundColor
	"used as background color for all panes"
	^ Color white! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'TudorGirba 12/1/2014 14:25'!
borderColor
	"color that is used for border and dividers of UI parts of Spotter
	for example divider between header and results or between preview and list"
	^ Color r: 180 g: 180 b: 180 range: 255! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'AliakseiSyrel 1/26/2015 15:39'!
breadcrumbHeight

	^ 26! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'AliakseiSyrel 1/25/2015 14:07'!
breadcrumbItemBackgroundColor

	^ self borderColor! !

!GTSpotterWidgetThemer methodsFor: 'styles' stamp: 'AliakseiSyrel 1/25/2015 14:12'!
breadcrumbItemLabelStyleFor: aBrick

	aBrick
		textPosition: #center;
		normalColor: self breadcrumbItemBackgroundColor;
		textColor: self breadcrumbItemTextColor;
		padding: { 0 . self outerBorderWidth }.
		
	aBrick layout vSpaceFill! !

!GTSpotterWidgetThemer methodsFor: 'styles' stamp: 'AliakseiSyrel 1/26/2015 00:11'!
breadcrumbItemStyleFor: aBrick! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'AliakseiSyrel 1/25/2015 14:07'!
breadcrumbItemTextColor

	^ Color white! !

!GTSpotterWidgetThemer methodsFor: 'styles' stamp: 'AliakseiSyrel 1/25/2015 14:08'!
breadcrumbItemTriangleStyleFor: aBrick

	aBrick renderer: (GTSpotterTriangleRenderer new orientation: #bottom).
	aBrick layout staticHeight: self breadcrumbTriangleHeight.
	aBrick color: self breadcrumbItemBackgroundColor! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'AliakseiSyrel 1/26/2015 01:02'!
breadcrumbSeparatorColor

	^ self breadcrumbItemBackgroundColor muchLighter slightlyDarker! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'AliakseiSyrel 1/26/2015 00:49'!
breadcrumbSeparatorLineWidth

	^ 2! !

!GTSpotterWidgetThemer methodsFor: 'styles' stamp: 'AliakseiSyrel 1/26/2015 00:43'!
breadcrumbSeparatorStyleFor: aBrick

	aBrick
		color: self breadcrumbItemBackgroundColor;
		borderWidth: self breadcrumbSeparatorLineWidth;
		borderColor: self breadcrumbSeparatorColor;
		renderer: GTSpotterBreadcrumbSeparatorRenderer new;
		width: self breadcrumbSeparatorWidth;
		height: self breadcrumbHeight + self outerBorderWidth.! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'AliakseiSyrel 1/26/2015 00:52'!
breadcrumbSeparatorWidth

	^ (self breadcrumbHeight + self outerBorderWidth) / 2 + 4 "we need slightly more because of drawing accuracy"! !

!GTSpotterWidgetThemer methodsFor: 'styles' stamp: 'AliakseiSyrel 1/27/2015 09:24'!
breadcrumbStyleFor: aBrick
	
	aBrick layout
		margin: { 0 . 0 }.
		
	aBrick layout
		staticHeight: self breadcrumbHeight;
		marginBottom: self breadcrumbTriangleHeight negated;
		zIndex: 2.! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'AliakseiSyrel 1/25/2015 15:33'!
breadcrumbTriangleHeight

	^ 16! !

!GTSpotterWidgetThemer methodsFor: 'acessing' stamp: 'AliakseiSyrel 1/26/2015 14:05'!
brickThemer

	^ GTSpotterBrickThemer default! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'AliakseiSyrel 10/23/2014 18:12'!
buttonPressedColor

	^ self backgroundColor darker! !

!GTSpotterWidgetThemer methodsFor: 'styles' stamp: 'AliakseiSyrel 1/11/2015 18:08'!
categoryAmountStyleFor: aBrick

	aBrick
		textPosition: #leftCenter;
		textColor: self titleTextColor;
		color: self titleBackgroundColor.
	
	aBrick label
		fontSize: self titleFontSize;
		familyName: self titleFamilyName.
	
	aBrick layoutProperties
		hSpaceFill;
		marginLeft: self categoryNameMarginRight.! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'AliakseiSyrel 12/1/2014 12:02'!
categoryMarginBottom

	^ (self itemHeight * (2/3)) ceiling "pixels"! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'AliakseiSyrel 11/27/2014 14:40'!
categoryNameMarginLeft

	^ self itemIconMaxWidth! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'AliakseiSyrel 11/18/2014 23:51'!
categoryNameMarginRight

	^ 10! !

!GTSpotterWidgetThemer methodsFor: 'styles' stamp: 'AliakseiSyrel 1/11/2015 18:08'!
categoryStyleFor: aBrick

	aBrick layoutProperties
		marginBottom: self categoryMarginBottom! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'AliakseiSyrel 1/23/2015 13:03'!
categoryTitleBackgroundColor

	^ Color white alpha: 0.95! !

!GTSpotterWidgetThemer methodsFor: 'styles' stamp: 'AliakseiSyrel 1/21/2015 13:57'!
categoryTitleNameStyleFor: aBrick

	aBrick
		textPosition: #leftCenter;
		textColor: self titleTextColor;
		color: self titleBackgroundColor.
	
	aBrick label
		fontSize: self titleFontSize;
		familyName: self titleFamilyName.
	
	aBrick layoutProperties
		staticWidth: [ :name | (aBrick owner innerBounds width) min: ((name label textSize x) + name label layoutProperties horizontalMargin) ].! !

!GTSpotterWidgetThemer methodsFor: 'styles' stamp: 'AliakseiSyrel 1/23/2015 13:03'!
categoryTitleStyleFor: aBrick

	aBrick
		layoutPolicy: GLMBrickHorizontalFillProportionalLinearLayout new;
		normalColor: self categoryTitleBackgroundColor;
		height: [ 30 ].
	
	aBrick layoutProperties
		floating: #stack;
		paddingLeft: self categoryNameMarginLeft;
		maxWidthBlock: [ :title |
			aBrick layoutProperties horizontalPadding + 
			(title nameBrick label textSize x )+ title amountBrick label textSize x +
			title nameBrick layoutProperties horizontalPadding + title nameBrick layoutProperties horizontalMargin + 
			title nameBrick label layoutProperties horizontalPadding + title nameBrick label layoutProperties horizontalMargin + 
			title amountBrick layoutProperties horizontalMargin ].! !

!GTSpotterWidgetThemer methodsFor: 'styles' stamp: 'AliakseiSyrel 1/11/2015 18:13'!
closeButtonStyleFor: aBrick

	aBrick
		normalImage: GLMUIThemeExtraIcons glamorousClose;
		pressedColor: self buttonPressedColor! !

!GTSpotterWidgetThemer methodsFor: 'styles' stamp: 'AliakseiSyrel 1/19/2015 21:11'!
dropDownPaneStyleFor: aBrick

	aBrick
		layoutProperties: GLMBrickLayoutProperties new;
		color: self backgroundColor.

	aBrick layoutProperties
		vSpaceFill;
		marginTop: self innerBorderWidth.! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'AliakseiSyrel 10/24/2014 14:55'!
headerHeight
	"height of the header where user enters search request"
	^ 56! !

!GTSpotterWidgetThemer methodsFor: 'styles' stamp: 'AliakseiSyrel 1/19/2015 21:03'!
headerStyleFor: aBrick

	aBrick
		color: self backgroundColor.
		
	aBrick layout
		staticHeight: [ self headerHeight ]! !

!GTSpotterWidgetThemer methodsFor: 'icons' stamp: 'AliakseiSyrel 1/12/2015 17:34'!
iconAct

	^ GLMUIThemeExtraIcons glamorousPlay! !

!GTSpotterWidgetThemer methodsFor: 'icons' stamp: 'AliakseiSyrel 1/12/2015 17:34'!
iconDiveIn

	^ GLMUIThemeExtraIcons glamorousRight! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'AliakseiSyrel 10/23/2014 18:03'!
innerBorderWidth
	"width of the border that separates panes in the spotter"
	^ 1! !

!GTSpotterWidgetThemer methodsFor: 'styles' stamp: 'AliakseiSyrel 1/23/2015 13:20'!
itemActionButtonStyleFor: aBrick

	aBrick
		width: [ aBrick normalImage width + aBrick layoutProperties horizontalPadding ];
		pressedColor: self itemActionSelectedBackgroundColor;
		padding: { 0 . self outerBorderWidth }! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'AliakseiSyrel 1/23/2015 13:20'!
itemActionSelectedBackgroundColor

	^ self itemSelectedBackgroundColor darker! !

!GTSpotterWidgetThemer methodsFor: 'styles' stamp: 'AliakseiSyrel 1/11/2015 18:14'!
itemActionbarInvisibleStyleFor: aBrick

	aBrick layoutProperties staticWidth: 0.! !

!GTSpotterWidgetThemer methodsFor: 'styles' stamp: 'AliakseiSyrel 1/11/2015 18:14'!
itemActionbarStyleFor: aBrick

	aBrick layoutPolicy: GLMBrickHorizontalFillLinearLayout new.
	
	aBrick layoutProperties
		marginRight: self outerBorderWidth.
	
	self itemActionbarInvisibleStyleFor: aBrick.! !

!GTSpotterWidgetThemer methodsFor: 'styles' stamp: 'AliakseiSyrel 1/21/2015 13:58'!
itemActionbarVisibleStyleFor: aBrick

	aBrick layoutProperties
		staticWidth: [ :actionbar | actionbar subbricks inject: (actionbar layoutProperties horizontalPadding + actionbar layoutProperties horizontalMargin) into: [ :width :each | width + each outerBounds width ] ].! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'AliakseiSyrel 10/25/2014 10:08'!
itemFamilyName

	^ 'Open Sans'! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'AliakseiSyrel 10/23/2014 19:39'!
itemFontSize

	^ 9! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'AliakseiSyrel 10/23/2014 19:24'!
itemHeight

	^ 30! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'TudorGirba 12/1/2014 09:44'!
itemHoveredBackgroundColor

	^ Color transparent! !

!GTSpotterWidgetThemer methodsFor: 'styles' stamp: 'AliakseiSyrel 10/23/2014 19:27'!
itemHoveredStyleFor: aBrick

	aBrick color: self itemHoveredBackgroundColor! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'AliakseiSyrel 10/23/2014 19:44'!
itemIconAlphaValue

	^ 0.8! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'AliakseiSyrel 10/23/2014 19:20'!
itemIconMaxWidth

	^ 50! !

!GTSpotterWidgetThemer methodsFor: 'styles' stamp: 'AliakseiSyrel 1/11/2015 18:04'!
itemIconStyleFor: aBrick
	"icon form must already be set before styling"
	
	"making icon a bit transparent"
	aBrick normalImage: (aBrick normalImage asAlphaImageMorph alpha: self itemIconAlphaValue) cachedForm.
	
	aBrick layoutProperties
		marginLeft: self titleMarginLeft;
		"margin right depends on maximal icon width and on image form width"
		marginRight: (self itemIconMaxWidth - aBrick normalImage width - aBrick layoutProperties marginLeft);
		staticWidth: (aBrick normalImage width + aBrick layoutProperties horizontalMargin).! !

!GTSpotterWidgetThemer methodsFor: 'styles' stamp: 'AliakseiSyrel 1/23/2015 13:08'!
itemLabelStyleFor: aBrick

	aBrick label
		familyName: self itemFamilyName;
		fontSize: self itemFontSize;
		textColor: self itemTextColor;
		highlightingLogic: [ :aCanvas :aRectangle | |bounds|
			"because font calculates text width wrong"
			bounds := aRectangle translateBy: (-3@0).
			aCanvas line: bounds bottomLeft to: bounds bottomRight width: 1 color: Color lightGray ].
	
	aBrick layoutProperties
		hSpaceFill;
		marginRight: self outerBorderWidth.! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'AliakseiSyrel 10/23/2014 19:27'!
itemNormalBackgroundColor

	^ Color transparent! !

!GTSpotterWidgetThemer methodsFor: 'styles' stamp: 'AliakseiSyrel 1/11/2015 18:15'!
itemNormalStyleFor: aBrick

	aBrick
		normalColor: self itemNormalBackgroundColor;
		selectedColor: self itemHoveredBackgroundColor;
		checkedColor: self itemSelectedBackgroundColor;
		height: [ self itemHeight ]! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'AliakseiSyrel 11/19/2014 00:16'!
itemSelectedBackgroundColor

	^ self backgroundColor darker! !

!GTSpotterWidgetThemer methodsFor: 'styles' stamp: 'AliakseiSyrel 11/19/2014 00:15'!
itemSelectedStyleFor: aBrick

	aBrick color: self itemSelectedBackgroundColor! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'AliakseiSyrel 1/23/2015 13:09'!
itemTextColor

	^ Color black! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'AliakseiSyrel 1/25/2015 20:18'!
outerBorderWidth
	"the width of the border around the whole spotter"
	^ 4! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'AliakseiSyrel 1/25/2015 23:02'!
previewArrowColor

	^ self itemSelectedBackgroundColor! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'AliakseiSyrel 1/26/2015 14:19'!
previewArrowGapHack

	^ self brickThemer scrollbarOffset + self brickThemer scrollbarWidth + self outerBorderWidth + 1"pager bug"! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'AliakseiSyrel 1/25/2015 23:30'!
previewArrowWidth

	^ (self itemHeight / 2) + self previewArrowGapHack! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'AliakseiSyrel 1/25/2015 20:18'!
previewBorderWidth

	^ self outerBorderWidth! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'AliakseiSyrel 1/27/2015 09:41'!
previewPaddingLeft

	^ self previewArrowWidth * 1.2! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'AliakseiSyrel 1/25/2015 17:48'!
previewWidthPercent

	^ 40! !

!GTSpotterWidgetThemer methodsFor: 'styles' stamp: 'AliakseiSyrel 1/26/2015 14:18'!
resultsPaneStyleFor: aBrick

	aBrick band layoutPolicy: GLMBrickVerticalLinedStackLayout new.
	aBrick layoutProperties horizontalPercent: self resultsPaneWidth.
	aBrick color: self backgroundColor.! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'AliakseiSyrel 10/25/2014 10:43'!
resultsPaneWidth
	"width in Percents of the results pane"
	^ 100"%"! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'AliakseiSyrel 1/23/2015 13:23'!
searchFieldCursorColor

	^ Color black! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'TudorGirba 11/19/2014 08:40'!
searchFieldFamilyName

	^ 'Source Sans Pro'! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'AliakseiSyrel 10/23/2014 19:50'!
searchFieldFontSize

	^ 15! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'AliakseiSyrel 10/25/2014 10:45'!
searchFieldMarginLeft

	^ 20! !

!GTSpotterWidgetThemer methodsFor: 'styles' stamp: 'AliakseiSyrel 1/23/2015 13:23'!
searchFieldStyleFor: aMorph

	aMorph
		layoutProperties: GLMBrickLayoutProperties new;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		color: Color transparent;
		textColor: self searchFieldTextColor;
		withoutAdornment;
		withGhostText: self spotterGhostText;
		autoAccept: true;
		borderColor: Color transparent.
		
	aMorph layoutProperties
		hSpaceFill;
		marginLeft: self searchFieldMarginLeft.
	
	aMorph ghostTextRuler
		fontName: self searchFieldFamilyName pointSize: self searchFieldFontSize.
		
	aMorph textArea
		font: (LogicalFont familyName: self searchFieldFamilyName pointSize: self searchFieldFontSize);
		backgroundColor: Color transparent.
		
	aMorph textArea cursor color: self searchFieldCursorColor! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'AliakseiSyrel 1/23/2015 13:13'!
searchFieldTextColor
	
	^ Color black! !

!GTSpotterWidgetThemer methodsFor: 'styles' stamp: 'AliakseiSyrel 1/27/2015 09:20'!
spotterContentsStyleFor: aBrick
	
	aBrick
		layout: GLMBrickVerticalFillProportionalLinearLayout new;
		borderColor: self borderColor;
		borderWidth: self outerBorderWidth;
		color: self borderColor.
	
	aBrick layout
		hSpaceFill;
		padding: self outerBorderWidth;
		zIndex: 2
	! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'TudorGirba 11/26/2014 12:22'!
spotterGhostText

	^ 'Spotter search'! !

!GTSpotterWidgetThemer methodsFor: 'styles' stamp: 'AliakseiSyrel 1/27/2015 09:20'!
spotterPaneStyleFor: aBrick
	
	aBrick layout: GLMBrickHorizontalFillProportionalLinearLayout new.
	aBrick layout
		hSpaceFill;
		vSpaceFill! !

!GTSpotterWidgetThemer methodsFor: 'styles' stamp: 'AliakseiSyrel 1/25/2015 23:42'!
spotterPreviewArrowContainerStyleFor: aBrick

	aBrick layout: GLMBrickVerticalScrollListLayout new;
		margin: {
			self headerHeight + self innerBorderWidth + self previewBorderWidth.
			0.
			self previewBorderWidth.
			self previewArrowGapHack negated }.
		
	aBrick layout
		staticWidth: self previewArrowWidth - self previewArrowGapHack;
		zIndex: 4.! !

!GTSpotterWidgetThemer methodsFor: 'styles' stamp: 'AliakseiSyrel 1/25/2015 23:26'!
spotterPreviewArrowStyleFor: aBrick

	aBrick
		renderer: (GTSpotterTriangleRenderer new orientation: #right);
		height: [ (self previewArrowWidth - self previewArrowGapHack ) * 2 ]! !

!GTSpotterWidgetThemer methodsFor: 'styles' stamp: 'AliakseiSyrel 1/27/2015 09:40'!
spotterPreviewCompositeStyleFor: aBrick

	aBrick layout
		hSpaceFill;
		margin: self previewBorderWidth;
		paddingLeft: self previewPaddingLeft! !

!GTSpotterWidgetThemer methodsFor: 'styles' stamp: 'AliakseiSyrel 1/27/2015 09:20'!
spotterPreviewStyleFor: aBrick
	
	aBrick
		borderColor: self borderColor;
		borderWidth: self previewBorderWidth;
		color: Color white.
	
	aBrick layout
		hPercent: self previewWidthPercent;
		margin: { self headerHeight + self innerBorderWidth. 0 . 0};
		marginLeft: (self previewBorderWidth + self previewArrowWidth) negated;
		zIndex: 1! !

!GTSpotterWidgetThemer methodsFor: 'styles' stamp: 'AliakseiSyrel 1/25/2015 14:32'!
spotterStyleFor: aBrick

	aBrick brickRoot layout: GLMBrickVerticalFillProportionalLinearLayout new! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'TudorGirba 11/17/2014 22:02'!
titleBackgroundColor

	^ Color transparent! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'AliakseiSyrel 10/23/2014 19:38'!
titleFamilyName
	^ 'Open Sans'.! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'AliakseiSyrel 11/27/2014 13:29'!
titleFontSize

	^ 9! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'AliakseiSyrel 11/18/2014 23:52'!
titleMarginLeft
	^ 20! !

!GTSpotterWidgetThemer methodsFor: 'values' stamp: 'AliakseiSyrel 10/23/2014 18:55'!
titleTextColor

	^ self titleBackgroundColor muchDarker! !

!Object methodsFor: '*GT-Spotter' stamp: 'TudorGirba 11/26/2014 14:35'!
asSpotterCandidateLink

	^ GTSpotterCandidateLink value: self! !

!Object methodsFor: '*GT-Spotter' stamp: 'TudorGirba 11/26/2014 14:35'!
asSpotterProcessorLink

	^ GTSpotterProcessorLink value: self! !

!Object methodsFor: '*GT-Spotter' stamp: 'TudorGirba 11/18/2014 23:22'!
spotterActDefault
	^ self inspect! !

!Object methodsFor: '*GT-Spotter' stamp: 'TudorGirba 1/28/2015 13:33'!
spotterPreviewIn: aComposite inContext: aSpotter

	| pragmas |
	pragmas := Pragma 
				allNamed: #spotterPreview: 
				from: self class 
				to: Object
				sortedUsing: [: x :y | (x argumentAt: 1) < (y argumentAt: 1)].
	pragmas do: [ :eachPragma | 
		(eachPragma selector findTokens: $:) size = 1 
			ifTrue: [ self perform: eachPragma selector with: aComposite ]. 
		(eachPragma selector findTokens: $:) size = 2
			ifTrue: [ self perform: eachPragma selector with: aComposite with: aSpotter ] ]! !

!Object methodsFor: '*GT-Spotter' stamp: 'TudorGirba 1/28/2015 12:57'!
spotterPreviewRawIn: aComposite
	<spotterPreview: 40>

	aComposite table
		title: [ self gtDisplayString ];
		display: [ :anObject | (anObject gtInspectorVariableValuePairs asSortedCollection asOrderedCollection yourself) addFirst: 'self' -> anObject; yourself ];
		column: 'Variable'
			evaluated: [:assoc |	GTObjectPrinter new asNonTruncatedTextFrom: assoc key ]
			styled: [ :aBrick | aBrick textPosition: #rightCenter; margin: #(0 15 0 0); textColor: Color lightGray; height: 30 ];
		column: 'Value'
			evaluated: [:assoc | GTObjectPrinter new asTruncatedTextFrom: assoc value ]
			styled: [ :aBrick | aBrick margin: #(0 0 0 15); height: 30 ];
		entity: self.
		
	self flag: 'move "entity: self" somewhere else, maybe'! !

!Object methodsFor: '*GT-Spotter' stamp: 'AliakseiSyrel 11/15/2014 17:15'!
spotterProcessorsFor: aSpotterStep
	
	^ ((Pragma 
		allNamed: #spotterOrder:
		from: self class 
		to: Object)
			sort: [ :first :second | (first argumentAt: 1) < (second argumentAt: 1) ])
			do: [ :pragma |
				self 
					perform: pragma selector 
					with: aSpotterStep ]! !

GLMStackedScrollPaneBrick subclass: #GTSpotterResultsBrick
	instanceVariableNames: 'stepModel categories'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-UI'!

!GTSpotterResultsBrick methodsFor: 'adding' stamp: 'AliakseiSyrel 1/27/2015 10:35'!
addCategory: aProcessor
	|titleBrick categoryBrick|
	
	titleBrick := self newTitleBrick on: self stepModel category: aProcessor.
	self theme spotterWidgetThemer categoryTitleStyleFor: titleBrick.
	self addBrickBack: titleBrick.
	
	categoryBrick := (self newCategoryBrick on: self stepModel category: aProcessor) titleBrick: titleBrick.
	self theme spotterWidgetThemer categoryStyleFor: categoryBrick .
	self addBrickBack: categoryBrick.
	
	self doLayout.
	self changed.
	
	^ categoryBrick! !

!GTSpotterResultsBrick methodsFor: 'adding' stamp: 'AliakseiSyrel 1/25/2015 19:16'!
buildItemFor: aCandidateLink in: aProcessor
	|itemBrick|
	itemBrick := (aCandidateLink renderingProcessor render: aCandidateLink value)
			candidateLink: aCandidateLink;
			stepModel: self stepModel;
			yourself.
	^ itemBrick
	! !

!GTSpotterResultsBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 12/9/2014 13:50'!
categories

	^ categories ifNil: [ categories := Dictionary new ]! !

!GTSpotterResultsBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/29/2014 14:50'!
categoryMorphOf: aProcessor

	^ self categories at: aProcessor ifAbsentPut: [ self addCategory: aProcessor ]! !

!GTSpotterResultsBrick methodsFor: 'initialization' stamp: 'AliakseiSyrel 1/25/2015 19:32'!
initialize
	super initialize.
	
	self announcer subscribe: GLMBrickScrollPositionChanged send: #onScrolled to: self! !

!GTSpotterResultsBrick methodsFor: 'instance creation' stamp: 'TudorGirba 11/26/2014 14:34'!
newCategoryBrick

	^ GTSpotterCategoryBrick new! !

!GTSpotterResultsBrick methodsFor: 'instance creation' stamp: 'AliakseiSyrel 11/29/2014 14:17'!
newTitleBrick

	^ GTSpotterCategoryTitleBrick new! !

!GTSpotterResultsBrick methodsFor: 'event handling' stamp: 'AliakseiSyrel 12/2/2014 16:05'!
onAllCandidatesAdded: ann
	|categoryMorph|
	ann candidateLinks isEmpty ifTrue: [ ^ self ].
	
	categoryMorph := self categoryMorphOf: ann category.
	
	ann candidateLinks do: [ :each | categoryMorph addBrickBack: (self buildItemFor: each in: ann category)	].
	
	categoryMorph titleBrick setAmountVisible: (categoryMorph submorphs size) all: self waitingText.

	self doLayout.
	self changed.! !

!GTSpotterResultsBrick methodsFor: 'event handling' stamp: 'AliakseiSyrel 1/27/2015 10:35'!
onAllCandidatesRemoved
	
	self removeAllBricks.
	categories := nil.
	
	self band fullReleaseCachedState.
	self band releaseCachedState.
	self doLayout.
	self changed.
	! !

!GTSpotterResultsBrick methodsFor: 'event handling' stamp: 'AliakseiSyrel 12/2/2014 16:01'!
onCandidateAdded: ann
	
	(self categoryMorphOf: ann category)
		addBrickBack: (self buildItemFor: ann candidateLink in: ann category);
		setAmountVisible: ((self categoryMorphOf: ann category) submorphs size) all: self waitingText.

	self doLayout.
	self changed.! !

!GTSpotterResultsBrick methodsFor: 'event handling' stamp: 'AliakseiSyrel 1/25/2015 23:46'!
onCandidateSelected: ann

	self scrollTo: ann candidateBrick.
	self brickRoot changed.! !

!GTSpotterResultsBrick methodsFor: 'event handling' stamp: 'AliakseiSyrel 1/25/2015 20:24'!
onCandidatesAmountChanged: ann
	|categoryMorph|
	
	ann amount < 1 ifTrue: [ ^ self changed ].
	
	categoryMorph := self categoryMorphOf: ann category.
	categoryMorph ifNil: [ ^ self ].
	
	categoryMorph titleBrick setAmountVisible: (categoryMorph submorphs size) all: ann amount.
	! !

!GTSpotterResultsBrick methodsFor: 'event handling' stamp: 'AliakseiSyrel 1/25/2015 19:34'!
onScrolled

	self stepModel spotter announce: GTSpotterCandidateSelectedMoved new! !

!GTSpotterResultsBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/25/2014 14:36'!
stepModel
	^ stepModel! !

!GTSpotterResultsBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 1/27/2015 10:58'!
stepModel: aModel
	stepModel := aModel.
	
	stepModel candidates announcer weak subscribe: GTSpotterCandidateAdded send: #onCandidateAdded: to: self.
	stepModel candidates announcer weak subscribe: GTSpotterAllCandidatesRemoved send: #onAllCandidatesRemoved to: self.
	stepModel candidates announcer weak subscribe: GTSpotterAllCandidatesAdded send: #onAllCandidatesAdded: to: self.
	stepModel candidates announcer weak subscribe: GTSpotterCandidatesAmountChanged send: #onCandidatesAmountChanged: to: self.
	stepModel spotter announcer weak subscribe: GTSpotterCandidateSelected send: #onCandidateSelected: to: self.! !

!GTSpotterResultsBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/20/2014 00:35'!
waitingText

	^ '...'! !
